/*
//=============================================================================================================
//
//		Name        : 	xGovern API Framework
//		Author      : 	Joe K. Kim (J.K.K.)
//		Site		:	xgovern.com
//		Version     : 	1.5.11
//		
//		!!! Proprietary !!!
//
//		© 2018 xGovern Inc., all rights reserved.
//		Unauthorized copying of this file, via any medium is strictly prohibited.
//		Written by Joe K. Kim <jkk@xgovern.com>
//
//=============================================================================================================
*/

var is_nodeJS_master, is_nodeJS, is_worker, is_xgov_webnode, beta_mode;
is_nodeJS = (new Function("try{return this===global;}catch(e){return false;}"))();
if(is_nodeJS){try{is_worker=require?false:true;}catch(e){is_worker = true;}}
else{is_worker = (new Function("try{document}catch(e){return true;}"))();}
is_nodeJS_master = (is_nodeJS && !is_worker);
if(is_worker && !is_nodeJS){
	importScripts("https://xgovern.com/nacl-fast.min.js");
	importScripts("https://xgovern.com/pako.min.js");
}

var time = function(){return Math.floor((new Date).getTime()/1000);}
var mtime = function(){return (new Date).getTime();}
var portable_error = function(e,c){
	if(!e) e = new Error; if(!c) c = "";
	if(typeof e === 'string') e = new Error(e); 
	return {message:e.message, stack:e.stack, name:e.name, code:e.code?e.code:c};
}
var sort_object_keys = function(obj){
	//TODO: what comparison & collation is the sort function using?
	return Object.keys(obj).sort().reduce(function(result,key){result[key] = obj[key]; return result;}, {});
}

var xgov = (function(){
	
	var xgov_interface_version = "1.4.23";
	var fs = is_nodeJS_master ? require('fs') : null;
	var prompt = is_nodeJS_master ? require('prompt') : null;
	var colors = is_nodeJS_master ? require('colors/safe') : null;
	var nacl_crypto = is_nodeJS_master ? require('tweetnacl') : nacl;
	var pako_lib = is_nodeJS_master ? require('pako') : pako;
	var threader = is_nodeJS_master ? require('tiny-worker') : (is_worker ? self.Worker : Worker);
	
	var master_node_connection = null;
	var master_node_connection_onloads = [];
	var ui_handler = null;
	var record_handler = null;
	var prompt_executing = false;

	const obj_const = Object.prototype.constructor;
	const arr_const = Array.prototype.constructor;
	var is_object = function(a){return (a && a.constructor === obj_const);}
	var is_array = function(a){return (a && a.constructor === arr_const);}
	var is_string = function(a){return (a && typeof a === 'string');}
	var is_function = function(a){return (a && typeof a === 'function');}
	var obj_neat_assign, arr_neat_assign;
	obj_neat_assign = function(a,b){
		var i,c,d;
		if(arguments.length === 2){
			if(!a || !b) throw new Error('Supplied argument is not an object');
			if(a.constructor !== obj_const || b.constructor !== obj_const) throw new Error('Supplied argument is not an object');
			for(var p in b){
				c = a[p];
				d = b[p];
				if(c === undefined || c === null){
					if(d && d.constructor === obj_const) a[p] = obj_neat_assign({},d);
					else if(d && d.constructor === arr_const) a[p] = arr_neat_assign([],d);
					else a[p] = d;
				}
				else if(c.constructor === obj_const && d !== null && d.constructor === obj_const){
					a[p] = obj_neat_assign({},c,d);
				}
				else if(c.constructor === arr_const && d !== null && d.constructor === arr_const){
					a[p] = arr_neat_assign([],c,d);
				}
				else{
					if(d && d.constructor === obj_const) a[p] = obj_neat_assign({},d);
					else if(d && d.constructor === arr_const) a[p] = arr_neat_assign([],d);
					else a[p] = d;
				}
			}
			a = sort_object_keys(a);
			return a;
		}
		else if(arguments.length >= 3){
			if(!a || a.constructor !== obj_const) throw new Error('Supplied argument is not an object');
			var arglen = arguments.length;
			for(i = 1; i < arglen; ++i){
				c = arguments[i];
				if(!c || c.constructor !== obj_const) throw new Error('Supplied argument is not an object');
				if(c !== undefined && c !== null && c.constructor === obj_const) obj_neat_assign(a,c);
			}
			a = sort_object_keys(a);
			return a;
		}
		else{
			a = sort_object_keys(a);
			return a;
		}
	}
	arr_neat_assign = function(a,b){
		var i,c,d;
		if(arguments.length === 2){
			if(!a || !b) throw new Error('Supplied argument is not an array');
			if(a.constructor !== arr_const || b.constructor !== arr_const) throw new Error('Supplied argument is not an array');
			var blen = b.length;
			for(i = 0; i < blen; ++i){
				c = a[i]; d = b[i];
				if(c === undefined || c === null){
					if(d && d.constructor === obj_const) a[i] = obj_neat_assign({},d);
					else if(d && d.constructor === arr_const) a[i] = arr_neat_assign([],d);
					else a[i] = d;
				}
				else if(c.constructor === obj_const && d !== null && d.constructor === obj_const){
					a[i] = obj_neat_assign({},c,d);
				}
				else if(c.constructor === arr_const && d !== null && d.constructor === arr_const){
					a[i] = arr_neat_assign([],c,d);
				}
				else{
					if(d && d.constructor === obj_const) a[i] = obj_neat_assign({},d);
					else if(d && d.constructor === arr_const) a[i] = arr_neat_assign([],d);
					else a[i] = d;
				}
			}
			return a;
		}
		else if(arguments.length >= 3){
			if(!a || a.constructor !== arr_const) throw new Error('Supplied argument is not an array');
			var arglen = arguments.length;
			for(i = 1; i < arglen; ++i){
				c = arguments[i];
				if(!c || c.constructor !== arr_const) throw new Error('Supplied argument is not an array');
				if(c !== undefined && c !== null && c.constructor === arr_const) arr_neat_assign(a,c);
			}
			return a;
		}
		else{
			return a;
		}
	}
	var verbose_stack_top = function(e){
		try{
			var split = e.stack.split("\n");
			var loc = split[1].split("at ")[1].split(" (");
			var func = loc[0].split("."); func = func[func.length-1];
			var src = "(at "+loc[1];
			return "[verbose; '"+ func + "']: " + e.message + " " + src;
		}
		catch(e){
			return "[Verbose: unknown_func]: " + e.message + " (at ?)";
		}
	}
	var if_verbose = function(options,e){
		if(e && options && options.verbose){
			if(is_string(e)) e = new Error(e);
			//options.verbose_handler ? options.verbose_handler(e) : console.log(e);
			options.verbose_handler ? options.verbose_handler(e) : (options.verbose_max ? console.log(e) : console.log(verbose_stack_top(e)));
			is_array(options.verbose_log) ? options.verbose_log.push(e) : null;
			is_array(options.verbose_logs) ? options.verbose_logs.push(e) : null;
		}
	}
	var progress_update = function(data,options){
		if(options && options.onprogress && !options._resolved) options.onprogress(data);
	}
	var resolve = function(data,options,e,do_throw){
		if(e && options && options.verbose){
			options.verbose_handler ? options.verbose_handler(e) : console.log(e)
			is_array(options.verbose_log) ? options.verbose_log.push(e) : null;
		}
		if(!e) e = new Error("Unspecified Error/Resolution.");
		if(do_throw){
			if(options && options.callback && !options._resolved){
				(data !== false && data !== null && data !== undefined) ? options.callback(null,data) : options.callback(e,data);
				options._resolved = function(){};
			}
			throw e;
		}
		else{
			if(options && options.callback && !options._resolved){
				(data !== false && data !== null && data !== undefined) ? options.callback(null,data) : options.callback(e,data);
				options._resolved = function(){};
			}
			return data;
		}
	}
	var sanitize_empty_string = function(a,options){
		if(!options) options = {};
		if(options.copy) a = JSON.parse(JSON.stringify(a));
		if(is_array(a)){
			var alen = a.length;
			for(var i = 0; i < alen; ++i){
				var b = a[i];
				if(b === ''){
					a[i] = null;
				}
				else if(is_array(b) || is_object(b)){
					sanitize_empty_string(b);
				}
			}
		}
		else if(is_object(a)){
			for(var p in a){
				var b = a[p];
				if(b === ''){
					a[p] = null;
				}
				else if(is_array(b) || is_object(b)){
					sanitize_empty_string(b);
				}
			}
		}
		return a;
	}
	var year = 86400*365, month = 86400*30, week = 86400*7, day = 86400, hour = 3600, minute = 60;

	var xgov_running_domain = 'xgovern.com';

	//Seed Rounds Cryptowallets
	const xgov_seed_btc_address = '1F5mZ6jZPJq7jFSgyTgeesBaPdymfSUdwv';
	const xgov_seed_eth_address = '0x78b270E7Bb8D7A58176F6dEB274BDF56BF68fbb7';
	const xgov_seed_ltc_address = 'LYdUXCG5apXVYa2kt4qxWE879Tn8wP3maK';
	const xgov_seed_xrp_address = 'rENETpoz7rnxbGpKbAbm6pCFS6HPbejuoH';
	
	const xgov_base30_dict = '1JWTME8ZXCY52ALFUK7H3Q4SRPG960';
	const xgov_base30_lookup = {};
	const xgov_base30_lookup_cc = [];
	const xgov_base30_zero = xgov_base30_dict.charAt(0);
	for(var i = 0;  i < xgov_base30_dict.length; ++i){
		var cc = xgov_base30_dict.charCodeAt(i);
		var ch = xgov_base30_dict.charAt(i);
		if(xgov_base30_lookup[ch] !== undefined) throw new Error("Bad Base30 Dictionary with Duplicate: "+ch);
		xgov_base30_lookup[ch] = i;
		xgov_base30_lookup_cc[cc] = i;
	}
	
	const xgov_base62_dict = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
	const xgov_base62_lookup = {};
	const xgov_base62_lookup_cc = [];
	const xgov_base62_zero = xgov_base62_dict.charAt(0);
	for(var i = 0;  i < xgov_base62_dict.length; ++i){
		var cc = xgov_base62_dict.charCodeAt(i);
		var ch = xgov_base62_dict.charAt(i);
		if(xgov_base62_lookup[ch] !== undefined) throw new Error("Bad Base62 Dictionary with Duplicate: "+ch);
		xgov_base62_lookup[ch] = i;
		xgov_base62_lookup_cc[cc] = i;
	}
	const xgov_basepath = is_nodeJS_master ? __dirname+"/xgov_data/" : "/xgov_data/";
	const xgov_head_start = 16; //
	const xgov_domain_byte = 4; //4,5
	const xgov_group_byte = 6; //6,7
	const xgov_index_byte = 8; //8~15
	const xgov_index_byte_length = 8;
	
	var buffer_decode = function(buffer){
		if(typeof buffer === 'string') return buffer;
		var buffer_uft16 = new Uint16Array(buffer.length/2);
		var len = buffer.length;
		var j = 0;
		for(var i = 0; i < len; ++i){
			buffer_uft16[i] = buffer[j]+buffer[j+1]*256;
			j += 2;
		}
		var iter = 65536; //64KB
		var safe_iteration = Math.ceil(buffer_uft16.length/iter);
		if(safe_iteration == 1){
			return String.fromCharCode.apply(null, buffer_uft16);
		}
		else{
			var total = [];
			for(var i = 0; i < safe_iteration; ++i)
				total.push(String.fromCharCode.apply(null, utf16_buffer.slice(i*iter,(i+1)*iter)));
			return total.join('');
		}
	}
	var buffer_encode = function(str){
		if(str instanceof Uint8Array) return str;
		var buffer = new ArrayBuffer(str.length*2); // 2 bytes for each char
		var buffer_uft16 = new Uint16Array(buffer);
		var len = str.length;
		for(var i = 0; i < len; ++i) buffer_uft16[i] = str.charCodeAt(i);
		return new Uint8Array(buffer);
	}
	var base30_encode = function(buffer,reverse){
		var front_pad = [], front_pad_length = 0;
		for(var i = 0; i < buffer.length-1; ++i){
			if(buffer[i] !== 0) break;
			front_pad.push(xgov_base30_zero);
			++front_pad_length;
		}
		var holder = []; holder.push(0);
		for(var i = front_pad_length; i < buffer.length; ++i){
			var spot = buffer[i];
			for(var j = 0; j < holder.length; ++j){
				spot += holder[j] << 8; holder[j] = spot % 30;
				spot = Math.floor(spot / 30);
			}
			while(spot > 0) {
				holder.push(spot % 30);
				spot = Math.floor(spot / 30);
			}
		}
		var fin = [];
		for(var i = 0; i < holder.length; ++i) fin.unshift(xgov_base30_dict[holder[i]]);
		if(!reverse){
			return front_pad.join('') + fin.join('');
		}
		else{
			fin.reverse();
			return fin.join('') + front_pad.join('');
		}
	}
	var base30_decode = function(str,reverse){
		var bytes = [0], carry = 0;
		var len = str.length;
		for(var i = 0; i < len; ++i){
			var v = xgov_base30_lookup[str[i]];
			if(v === undefined) throw new Error("Character '"+str[i]+"' is not recognized by the internal base30 alphabets. ("+xgov_base30_dict+")");
			carry = v;
			for(var j = 0; j < bytes.length; ++j){
				carry += bytes[j] * 30;
				bytes[j] = carry & 255;
				carry >>= 8;
			}
			while(carry > 0){
				bytes.push(carry & 255);
				carry >>= 8;
			}
		}
		var zero_cc = xgov_base30_dict.charAt(0);
		var len = str.length-1;
		for(var i = 0; i < len; ++i){
			if(str[i] !== zero_cc) break;
			bytes.push(0);
		}
		if(!reverse) bytes.reverse();
		var result = new Uint8Array(bytes);
		return result;
	}
	var base62_encode = function(buffer,reverse){
		var front_pad = [], front_pad_length = 0;
		for(var i = 0; i < buffer.length-1; ++i){
			if(buffer[i] !== 0) break;
			front_pad.push(xgov_base62_zero);
			++front_pad_length;
		}
		var holder = []; holder.push(0);
		for(var i = front_pad_length; i < buffer.length; ++i){
			var spot = buffer[i];
			for(var j = 0; j < holder.length; ++j){
				spot += holder[j] << 8; holder[j] = spot % 62;
				spot = Math.floor(spot / 62);
			}
			while(spot > 0) {
				holder.push(spot % 62);
				spot = Math.floor(spot / 62);
			}
		}
		var fin = [];
		for(var i = 0; i < holder.length; ++i) fin.unshift(xgov_base62_dict[holder[i]]);
		if(!reverse){
			return front_pad.join('') + fin.join('');
		}
		else{
			fin.reverse();
			return fin.join('') + front_pad.join('');
		}
	}
	var base62_decode = function(str,reverse){
		var bytes = [0], carry = 0;
		var len = str.length;
		for(var i = 0; i < len; ++i){
			var v = xgov_base62_lookup[str[i]];
			if(v === undefined) throw new Error("Character '"+str[i]+"' is not recognized by the internal base62 alphabets. ("+xgov_base62_dict+")");
			carry = v;
			for(var j = 0; j < bytes.length; ++j){
				carry += bytes[j] * 62;
				bytes[j] = carry & 255;
				carry >>= 8;
			}
			while(carry > 0){
				bytes.push(carry & 255);
				carry >>= 8;
			}
		}
		var zero_cc = xgov_base62_dict.charAt(0);
		var len = str.length-1;
		for(var i = 0; i < len; ++i){
			if(str[i] !== zero_cc) break;
			bytes.push(0);
		}
		if(!reverse) bytes.reverse();
		var result = new Uint8Array(bytes);
		return result;
	}
	var base64_encode = function(data){
		if(!data) throw new Error('Data not supplied.');
		if(data instanceof Uint8Array) data = String.fromCharCode.apply(null,data);
		if(is_nodeJS_master){
			if(is_string(data)) return Buffer.from(data).toString('base64');
			else throw new Error('Data type unknown; must be string or Uint8Array.');
		}
		else{
			try{btoa; return btoa(data);}catch(e){}
		}
		var b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
		var o1, o2, o3, h1, h2, h3, h4, bits, i = 0,
		ac = 0, enc = "", tmp_arr = [];
		do{
			o1 = data.charCodeAt(i++);
			o2 = data.charCodeAt(i++);
			o3 = data.charCodeAt(i++);
			bits = o1 << 16 | o2 << 8 | o3;
			h1 = bits >> 18 & 0x3f;
			h2 = bits >> 12 & 0x3f;
			h3 = bits >> 6 & 0x3f;
			h4 = bits & 0x3f;
		
			tmp_arr[ac++] = b64.charAt(h1) + b64.charAt(h2) + b64.charAt(h3) + b64.charAt(h4);
		} 
		while(i < data.length);
		enc = tmp_arr.join('');
		var r = data.length % 3;
		return (r ? enc.slice(0, r - 3) : enc) + '==='.slice(r || 3);
	}
	var base64_decode = function(data,raw){
		if(!data) throw new Error('Data not supplied.');
		if(data instanceof Uint8Array) data = String.fromCharCode.apply(null,data);
		if(is_nodeJS_master){
			if(is_string(data)){
				if(raw){
					var dec = Buffer.from(data,'base64').toString('ascii');
					var declen = dec.length;
					var ret = new Uint8Array(declen);
					for(var i = 0; i < declen; ++i) ret[i] = dec.charCodeAt(i);
					return ret;
				}
				else{
					return Buffer.from(data,'base64').toString('ascii');
				}
			}
			else throw new Error('Data type unknown; must be string or Uint8Array (or any array with buffer property).');
		}
		else{
			try{atob; return atob(data);}catch(e){}
		}
		var b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
		var o1, o2, o3, h1, h2, h3, h4, bits, i = 0,
		ac = 0, dec = "", tmp_arr = [];
		data += '';
		do{
			h1 = b64.indexOf(data.charAt(i++));
			h2 = b64.indexOf(data.charAt(i++));
			h3 = b64.indexOf(data.charAt(i++));
			h4 = b64.indexOf(data.charAt(i++));
			bits = h1 << 18 | h2 << 12 | h3 << 6 | h4;
			o1 = bits >> 16 & 0xff;
			o2 = bits >> 8 & 0xff;
			o3 = bits & 0xff;
			if(h3 == 64) tmp_arr[ac++] = String.fromCharCode(o1);
			else if (h4 == 64) tmp_arr[ac++] = String.fromCharCode(o1, o2);
			else tmp_arr[ac++] = String.fromCharCode(o1, o2, o3);
		
		}
		while(i < data.length);
		dec = tmp_arr.join('');
		if(raw) return buffer_encode(dec);
		return dec;
	}
	var hex_encode = function(bytes){
		if(is_nodeJS_master){
			return Buffer.from(bytes).toString('hex');
		}
		else{
			return Array.from(bytes,function(b){
				return ('0'+(b & 0xFF).toString(16)).slice(-2);
			}).join('');
		}
	}
	var hex_decode = function(str){
		var result = new Uint8Array(str.length / 2);
		for(var i = 0; i < str.length; i += 2)
			result[i/2] = parseInt(str.substring(i, 2), 16);
		return result;
	}
	var gzip_compress = function(str,mode){if(!mode) mode='string'; return pako_lib.gzip(str,{to:mode});}
	var gzip_decompress = function(str,raw){return pako_lib.ungzip(str,{raw:raw?true:false,to:'string'});}
	var ntime = function(){
		//mtime + micro-nano index
		var a = nacl_crypto.randomBytes(4);
		var ns = (16777216*a[3] + 65536*a[2] + 256*a[1] + a[0]) % 1000000;
		var nts = mtime()*1000000 + ns;
		return nts;
	}
	var seed_shuffle = function(seed_bytes,arr){
		if(!seed_bytes) return false;
		var len;
		if(!is_array(arr)){
			if(isNaN(arr)) arr = 100;
			len = Math.round(Math.abs(arr));
			arr = []; arr.length = len;
			for(var i = 0; i < len; ++i) arr[i] = i;
		}
		len = arr.length;
		var index_array = []; index_array.length = len;
		var pointer_array = []; pointer_array.length = len;
		var result_array = []; result_array.length = len;
		var entropy_bytes = nacl_crypto.hash(seed_bytes);
		for(var i = 0; i < len; ++i) index_array[i] = i;
		var count = 0, pool = len;
		for(var i = 0; i < len; ++i){
			entropy_bytes = nacl_crypto.hash(entropy_bytes);
			var n = (16777216*entropy_bytes[3] + 65536*entropy_bytes[2] + 256*entropy_bytes[1] + entropy_bytes[0]);
			var idx = n % pool, idx2 = index_array[idx]; index_array.splice(idx,1);
			--pool; pointer_array[i] = idx2;
		}
		for(var i = 0; i < len; ++i) result_array[pointer_array[i]] = arr[i];
		return result_array;
	}
	
	/*	SYSGOD Genesis account
		Jan. 1st 2020, singular SYSGOD commands are no longer accepted worldwide; 
		it must accompany 2/3-majority certificates from public "High Council" 
		(distributed 144+ accounts around the world)
	*/
	var xgov_sysgod_address = 'xGOD_LxMpUjaCevPghnzFgODQLwnQub3c7uWXK7KSvwhkwwR';
	var xgov_sysgod_key = null;
	var xgov_sysgod_key_fetch_time = 0;
	var xgov_sysgod_key_fetch_exp = 0;
	var xgov_sysgod_key_fetch_exp_default = 1200 * 1000;
	var xgov_sysgod_genesis_expire = 1577836800000; //Genesis period expires 2020 Jan 1st 00:00:00
	
	var xgov_current_secret = null;
	var xgov_current_secret_fetch_time = 0;
	var xgov_current_secret_fetch_exp = 0;
	var xgov_current_secret_onloads = [];
	
	var xgov_timestamper_secret = null;
	var xgov_timestamper_secret_fetch_time = 0;
	var xgov_timestamper_secret_fetch_exp = 0;
	var xgov_timestamper_secret_onloads = [];
	
	var xgov_default_pwxor_password = null;
	
	var xgov_default_timeserver = 'x_XzOw9o048uk5jwSqKE1rUpASe8plQCKEG3JreiUHU0r';
	
	var xgov_public_address = 'xPUB_d2X9APeFRRWPVMG1pUBc17QEh5e4h5p0Wg31xLyDvLJ';
	var xgov_public_decrypt = '5kzTwtzeKzqslOgg23sGRV28xuNp2vtnh1Gtpkd1n74';
	var xgov_public_public_key = base62_decode('d2X9APeFRRWPVMG1pUBc17QEh5e4h5p0Wg31xLyDvLJ');
	var xgov_public_private_key = base62_decode('5kzTwtzeKzqslOgg23sGRV28xuNp2vtnh1Gtpkd1n74');
	var xgov_public_nonce = new Uint8Array(24);
	for(var i = 0; i < 24; ++i) xgov_public_nonce[i] = i;
	
	var xgov_default_master = 'wss://xgovern.com/master-ws';
	var xgov_default_master_test = 'wss://xgovern.com/master-ws-test';
	
	var domain_length_convert = function(v){
		if(v < 31){return 0;}//length 0 case 50%
		else if(v < 51){return 1;}//length 1 case 32%
		else if(v < 55){return 2;}//length 2 case 6.5%
		else return v - (55 - 3); //length 3~8 (1.5% each)
	}
	var domain_length_from_keystr = function(address){
		return domain_length_convert(xgov_base62_lookup[address.charAt(xgov_domain_byte)]);
	}
	var group_length_convert = function(v){
		if(v > 1){//+2 case
			if(v < 33) return 2; //50%
			else if(v < 41) return 3; //13%
			else if(v < 47) return 4; //9.6%
			else if(v < 50) return 5; //4.8% 
			else if(v < 52) return 6; //3.2%
			else return v - 52 + 7; // 1.5% each
		}
		else{return v;} //0 or 1 case
	}
	var group_length_from_keystr = function(address){
		return group_length_convert(xgov_base62_lookup[address.charAt(xgov_group_byte)]);
	}
	var keystr_header_length_check = function(address,dlen,glen){
		var dv = xgov_base62_lookup[address[xgov_domain_byte]];
		var _dlen = 0;
		if(dv < 31){_dlen = 0;}//length 0 case 50%
		else if(dv < 51){_dlen = 1;}//length 1 case 32%
		else if(dv < 55){_dlen = 2;}//length 2 case 6.5%
		else _dlen = dv - ( 55 - 3); //length 3~8 (1.5% each)
		if(_dlen !== dlen) return false;
		var _glen = 0;
		var gv = xgov_base62_lookup[address[xgov_group_byte]];
		if(gv > 1){//+2 case
			if(gv < 33) _glen = 2; //50%
			else if(gv < 41) _glen = 3; //13%
			else if(gv < 47) _glen = 4; //9.6%
			else if(gv < 50) _glen = 5; //4.8% 
			else if(gv < 52) _glen = 6; //3.2%
			else _glen = gv - 52 + 7; // 1.5% each
		}
		else{_glen = gv;} //0 or 1 case
		if(_glen !== glen) return false;
		return true;
	}
	var string_version_compare = function(a,b){
		a = a.split("."); b = b.split(".");
		var subversion_count = (a.length > b.length) ? a.length : b.length;
		var c,d;
		for(var i = 0; i < subversion_count; ++i){
			c = parseInt(a[i]), d = parseInt(b[i]);
			if(isNaN(c)) c = 0; if(isNaN(d)) d = 0;
			if(c === d){
				continue;
			}
			else if(c > d){
				return 1;
			}
			else{
				return -1;
			}
		}
		return 0;
	}
	
	var thread_execute_default_wait = 60*1000; //10 sec default timeout
	var thread_execute_max_concurrent = is_nodeJS ? 64 : 10000; //concurrent thread functions per thread
	var thread_execute_max_backlog = 1000000;
	var thread_backlog_being_handled, thread_backlog_checkers = [];
	var threads = [], nodes = [], webnodes = [], thd_exe_backlog = [];
	var node_com = {}; node_com_fid = 0;
	
	var protocol_logic = {};
	
	var sender_by_name = {};
	var sender_by_address = {};
	var add_known_sender = function(name,address,types){
		if(!sender_by_name[name]){
			sender_by_name[name] = sender_by_address[address] = {
				name:name, address:address, types:types
			};
		}
	}
	add_known_sender("SYSGOD",xgov_sysgod_address,{sysgod:1,timeauth:1,codeauth:1});
	
	var xgov_command_line_interface_checker = null;
	var xgov_command_line_interface_exit_flag = false;
	
	var THREAD_BACKLOG_FLAG = 2;
	
	var docs = (!is_worker && !is_nodeJS);
	var codebase = {}, codebase_initialized = false;
	var xgov = {};
	
	var address_codecs = {};
	
	var apiOK = false;
	
	xgov. address_codec_add = function(param,options){
		//if(!apiOK) return resolve(false,options,new Error('API key is not set or verified'));
		if(!options) options = {};
		var codec_name = param.name;
		if(address_codecs[codec_name]) return resolve(false,options,new Error('Address codec '+codec+' already exists.'));
		var alphabet = param.alphabet;
		var codec_base = param.base, codec_lookup = {}, codec_lookup_cc = [];
		var codec_dict = param.alphabet;
		var codec_zero = codec_dict.charAt(0);
		for(var i = 0;  i < codec_dict.length; ++i){
			var cc = codec_dict.charCodeAt(i);
			var ch = codec_dict.charAt(i);
			if(codec_lookup[ch] !== undefined) throw new Error("Bad Base58 Dictionary with Duplicate: "+ch);
			codec_lookup[ch] = i;
			codec_lookup_cc[cc] = i;
		}
		var codec_encode = function(buffer,reverse){
			var front_pad = [], front_pad_length = 0;
			for(var i = 0; i < buffer.length-1; ++i){
				if(buffer[i] !== 0) break;
				front_pad.push(codec_zero);
				++front_pad_length;
			}
			var holder = []; holder.push(0);
			for(var i = front_pad_length; i < buffer.length; ++i){
				var spot = buffer[i];
				for(var j = 0; j < holder.length; ++j){
					spot += holder[j] << 8; holder[j] = spot % codec_base;
					spot = Math.floor(spot / codec_base);
				}
				while(spot > 0) {
					holder.push(spot % codec_base);
					spot = Math.floor(spot / codec_base);
				}
			}
			var fin = [];
			for(var i = 0; i < holder.length; ++i) fin.unshift(codec_dict[holder[i]]);
			if(!reverse){
				return front_pad.join('') + fin.join('');
			}
			else{
				fin.reverse();
				return fin.join('') + front_pad.join('');
			}
		}
		var codec_decode = function(str,reverse){
			var bytes = [0], carry = 0;
			var len = str.length;
			for(var i = 0; i < len; ++i){
				var v = codec_lookup[str[i]];
				if(v === undefined) throw new Error("Character '"+str[i]+"' is not recognized by the internal base"+codec_base+" alphabets. ("+codec_dict+")");
				carry = v;
				for(var j = 0; j < bytes.length; ++j){
					carry += bytes[j] * codec_base;
					bytes[j] = carry & 255;
					carry >>= 8;
				}
				while(carry > 0){
					bytes.push(carry & 255);
					carry >>= 8;
				}
			}
			var zero_cc = codec_dict.charAt(0);
			var len = str.length-1;
			for(var i = 0; i < len; ++i){
				if(str[i] !== zero_cc) break;
				bytes.push(0);
			}
			if(!reverse) bytes.reverse();
			var result = new Uint8Array(bytes);
			return result;
		}
		var codec_check = function(str){
			var len = str.length;
			for(var i = 0; i < len; ++i){
				var v = codec_lookup[str[i]];
				if(v === undefined) return false;
			}
			return true;
		}
		var codec = address_codecs[codec_name] = {
			alphabet:alphabet,
			base:codec_base,
			encode:codec_encode,
			decode:codec_decode,
			check:codec_check
		};
		return resolve(codec,options);
	}
	xgov. address_codec_initialize = function(param,options){
		if(!options) options = {};
		var codec_name = param.name;
		var buffer = param.buffer;
		var codec;
		if(codec_name == 'bitcoin'){
			codec = address_codecs[codec_name]; if(!codec){
				codec = xgov. address_codec_add({
					name:codec_name,
					alphabet:'123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz',
					base:58
				});
			}
		}
		else if(codec_name == 'ripple'){
			codec = address_codecs[codec_name]; if(!codec){
				codec = xgov. address_codec_add({
					name:codec_name,
					alphabet:'rpshnaf39wBUDNEGHJKLM4PQRST7VWXYZ2bcdeCg65jkm8oFqi1tuvAxyz',
					base:58
				});
			}
		}
		else if(codec_name == 'stellar'){
			codec = address_codecs[codec_name]; if(!codec){
				codec = xgov. address_codec_add({
					name:codec_name,
					alphabet:'gsphnaf39wBUDNEGHJKLM4PQRST7VWXYZ2bcdeCr65jkm8oFqi1tuvAxyz',
					base:58
				});
			}
		}
		else{
			return resolve(false,options,new Error('No address codec found with name "'+codec_name+'"'));
		}
		return true;
	}
	xgov. address_codec_encode = function(param,options){
		if(!options) options = {};
		var codec_name = param.name;
		if(!xgov. address_codec_initialize(param)) return resolve(false,options,new Error('Cannot initialize address codec "'+param.name+'"'));
		var encoded = address_codecs[codec_name].encode(param.buffer);
		return resolve(decoded,options);
	}
	xgov. address_codec_decode = function(param,options){
		if(!options) options = {};
		var codec_name = param.name;
		if(!xgov. address_codec_initialize(param)) return resolve(false,options,new Error('Cannot initialize address codec "'+param.name+'"'));
		var decoded = address_codecs[codec_name].decode(param.encoded);
		return resolve(decoded,options);
	}
	
	xgov. credentials_from_key = function(key,options){
		/* ARG: key = base62 string or Uint8Array //secret key
				options = {callback:function, raw:bool}
			USAGE, sync/async
		*/
		if(docs) return {};
		if(!options) options = {};
		if(!(key instanceof Uint8Array)){
			if(typeof key == 'string') key = base62_decode(key);
			else throw new Error('Private key must be of type base62 encoded string or Uint8Array.');
		}
		var key_pair = nacl_crypto.box.keyPair.fromSecretKey(key);
		if(!options.callback){
			if(options.raw){
				return key_pair.publicKey;
			}
			else{
				return {
					address: xgov.get_address_from_public_key(key_pair.publicKey),
					secret: base62_encode(key_pair.secretKey)
				};
			}
		}
		else{
			if(options.raw){
				options.callback(null,key_pair.publicKey);
			}
			else{
				options.callback(null,{
					address: xgov.get_address_from_public_key(key_pair.publicKey),
					secret: base62_encode(key_pair.secretKey)
				});
			}
		}
	};
	xgov. credentials_from_secret = function(secret,options){
		if(docs) return {};
		var private_key = (typeof secret == 'object') ? secret : base62_decode(secret);
		return xgov.credentials_from_key(private_key);
	};
	
	xgov. generate_address = function(param,options){
		if(docs) return {};
		if(!param) param = {}; if(!options) options = {};
		var group = param.group;
		var test = param.test;
		var async_mod = param.async_interval ? param.async_interval : 300;
			if(async_mod < 100) async_mod = 100;
		var domain = param.domain ? param.domain : '';
		if(domain === undefined || domain === null) group = '';
		if(domain == 'x' || domain == 'X') domain = '';
		if(group === undefined || group === null) group = '';
		group = (group + '').toUpperCase();
		domain = (domain + '').toLowerCase();
		var domain_len = domain.length;
		var group_len = group.length;
		var group_ori = group;
		
		if(group.length > 10)
			return resolve(false, options, new Error('Group header length is too long (over 10 chars)'));
		
		if(!options.callback){
			var total_tried = 0, length_pass_count = 0, domain_pass_count = 0;
			var count = 0, max_count = 1000000000, passed = false;
			var dlen, glen, dhead, ghead, key_pair, addr_b62;
			do{
				++total_tried; ++count; 
				if(count >= max_count) 
					return resolve(false, options, new Error('Taking too long to generate address (>'+max_count+' tries, to get '+group_ori+')'));
				key_pair = nacl_crypto.box.keyPair();
				addr_b62 = base62_encode(key_pair.publicKey); if(addr_b62.length == 42) continue; //block 1~2% short addr chance
				if(!keystr_header_length_check(addr_b62, domain_len, group_len)) continue;
				if(domain_len > 0){dhead = addr_b62.substr(xgov_head_start, domain_len).toLowerCase(); if(dhead !== domain) continue;}
				if(group_len > 0){ghead = addr_b62.substr(xgov_head_start + domain_len, group_len).toUpperCase(); if(ghead !== group) continue;}
				passed = true; break;
			}
			while(true);
			var result = xgov.credentials_from_key(key_pair.secretKey);
			return resolve(result, options, new Error('Finished '+JSON.stringify({count:total_tried, domain:domain, group:group})));
		}
		else if(async_mod >= 100 && options.callback){
			var total_tried = 0, length_pass_count = 0, domain_pass_count = 0;
			var dlen, glen, dhead, ghead, key_pair, addr_b62;
			var checker_id = setInterval(function(){
				var count = 0, max_count = async_mod, passed = false;
				do{
					++total_tried; ++count; if(count >= max_count) break;
					key_pair = nacl_crypto.box.keyPair();
					addr_b62 = base62_encode(key_pair.publicKey); if(addr_b62.length == 42) continue; //block 1~2% short addr chance
					if(!keystr_header_length_check(addr_b62, domain_len, group_len)) continue;
					if(domain_len > 0){dhead = addr_b62.substr(xgov_head_start, domain_len).toLowerCase(); if(dhead !== domain) continue;}
					if(group_len > 0){ghead = addr_b62.substr(xgov_head_start + domain_len, group_len).toUpperCase(); if(ghead !== group) continue;}
					passed = true; break;
				}
				while(true);
				if(!passed){
					progress_update({count:total_tried, domain:domain, group:group},options);
				}
				else{
					clearInterval(checker_id);
					var result = xgov.credentials_from_key(key_pair.secretKey);
					return resolve(result, options, new Error('Finished '+JSON.stringify({count:total_tried, domain:domain, group:group})));
				}
			},0);
		}
		else{
			return resolve(false, options, new Error('Arguments not valid: async mod too low or no callback given.'));
		}
	};
	
	xgov. get_address_from_public_key = function(public_key,options){
		if(docs) return {};
		var addr_b62 = (typeof public_key == 'string') ? public_key : base62_encode(public_key);
		var dlen = domain_length_from_keystr(addr_b62); //domain length
		var glen = group_length_from_keystr(addr_b62); //group length
		var dhead = addr_b62.substr(xgov_head_start, dlen).toLowerCase(); //Domain name
		if(dhead == '') dhead = 'x';
		var ghead = addr_b62.substr(xgov_head_start + dlen, glen).toUpperCase(); //Group name
		return dhead + ghead + '_' + addr_b62;
	};
	xgov. get_public_key_from_address = function(address,options){
		if(docs) return {};
		if(!options) options = {};
		if(address instanceof Uint8Array) return address;
		var keypart_b62 = address.split('_')[1];
		if(options.base62) return keypart_b62;
		return base62_decode(keypart_b62);
	};
	xgov. get_address_index = function(address,options){
		if(docs) return {};
		if(!address) throw new Error('Address not given');
		if(address instanceof Uint8Array) address = get_address_from_public_key(address);
		var keypart_b62 = address.split('_')[1];
		return keypart_b62.substr(xgov_index_byte,xgov_index_byte_length);
	};
	
	xgov. raw_encode_public_message = function(param,options){
		if(docs) return {};
		return xgov.raw_encode_message({
			message:param.message,
			nonce:xgov_public_nonce,
			recv_pubkey:xgov_public_public_key,
			secret:param.secrey,
		},options);
	};
	xgov. raw_encode_message = function(param,options){
		if(docs) return {};
		try{
			var message = param.message;
			var nonce = param.nonce;
			var recv_pubkey = param.recv_pubkey;
			var secret = param.secret;
			var my_private_key = (typeof secret == 'object') ? secret : base62_decode(secret);
			var my_pubkey = param.signer ? xgov.get_public_key_from_address(param.signer) : xgov.credentials_from_key(my_private_key,{raw:true});
			var nonce = nonce ? nonce : nacl_crypto.randomBytes(24);
			var encoded = nacl_crypto.box(message, nonce, recv_pubkey, my_private_key);
			var result = [recv_pubkey, my_pubkey, nonce, encoded];
			return resolve(result,options);
		}
		catch(e){
			return resolve(false,options,e);
		}
	};
	xgov. raw_decode_message = function(data,options){
		if(docs) return {};
		var secret = options.secret;
		var my_private_key = (typeof secret == 'object') ? secret : base62_decode(secret);
		var signer_pubkey = xgov.get_public_key_from_address(data[2]);
		var encoded = nacl_crypto.box.open(data[4], data[3], signer_pubkey, my_private_key);
		return encoded;
	};
	
	xgov. encode_message = function(param,options){
		if(docs) return {};
		if(!options) options = {};
		var message = param.message;
		var to_address = param.to;
		var my_secret = param.secret;
		var encoding_codec = param.codec; if(!encoding_codec) encoding_codec = 'b62';
		if(typeof message == 'string') message = buffer_encode(message);
		var recv_public_key = xgov.get_public_key_from_address(to_address);
		var encoded_arr = xgov.raw_encode_message({
			message:message,
			nonce:null, //random nonce
			recv_pubkey:recv_public_key,
			secret:my_secret
		});
		var scheme = param.scheme ? param.scheme : 'open'; // blind, noto, nofrom, open
		var result;
		if(scheme == 'blind'){
			result = [
				{enc:encoding_codec}, //0 meta, encoding, etc
				0, //1 Receiver Address
				0, //2 Sender Address
				base62_encode(encoded_arr[2]), //3 Nonce
				base62_encode(encoded_arr[3]), //4 Data
			];
		}
		else if(scheme == 'noto'){
			result = [
				{enc:encoding_codec}, //0 meta, encoding, etc
				0, //1 Receiver Address
				xgov.get_address_from_public_key(encoded_arr[1]), //2 Sender Address
				base62_encode(encoded_arr[2]), //3 Nonce
				base62_encode(encoded_arr[3]), //4 Data
			];
		}
		else if(scheme == 'nofrom'){
			result = [
				{enc:encoding_codec}, //0 meta, encoding, etc
				to_address, //1 Receiver Address
				0,
				base62_encode(encoded_arr[2]), //3 Nonce
				base62_encode(encoded_arr[3]), //4 Data
			];
		}
		else if(scheme == 'open'){
			result = [
				{enc:encoding_codec}, //0 meta, encoding, etc
				to_address, //1 Receiver Address
				xgov.get_address_from_public_key(encoded_arr[1]), //2 Sender Address
				base62_encode(encoded_arr[2]), //3 Nonce
				base62_encode(encoded_arr[3]), //4 Data
			];
		}
		else{
			var e = new Error('Unknown exchange scheme '+scheme);
			if(!options.callback) throw e; else options.callback(e);
		}
		if(!options.callback) return result; else options.callback(null,result);
	};
	xgov. decode_message = function(param,options){
		if(docs) return {};
		if(!options) options = {};
		var data = param.data;
		var secret = param.secret;
		var dat;
		var msg_meta = data[0];
		var is_signature = (data.length <= 4);
		var decoding_codec = msg_meta.enc; if(!decoding_codec) decoding_codec = 'b62';
		var crypto_scheme = msg_meta.crypto; if(!crypto_scheme) crypto_scheme = 'NaCl-Box-x25519';
		var decode_scheme;
		if(decoding_codec == 'b62') decode_scheme = base62_decode;
		else if(decoding_codec == 'b64') decode_scheme = base64_decode;
		else if(decoding_codec == 'hex') decode_scheme = hex_decode;
		var sender = is_signature ? data[1] : data[2];
		if(sender === null || sender === undefined){
			var e = new Error("Sender address not defined in the encoded message");
			if(!options.callback) throw e; else return options.callback(e);
		}
		if(sender_by_name[sender]) sender = xgov.get_public_key_from_address(sender_by_name[sender].address,{base62:true});
		var sender_address = (sender.indexOf("_") >= 0) ? sender : xgov.get_address_from_public_key(base62_decode(sender));
		if(is_signature){//Public signature/message
			secret = xgov_public_private_key;
			dat = [data[0], xgov_public_public_key, sender_address, decode_scheme(data[2]), decode_scheme(data[3])];
		}
		else{
			dat = [data[0], data[1], sender_address, decode_scheme(data[3]), decode_scheme(data[4])];
		}
		var message;
		if(crypto_scheme === 'NaCl-Box-x25519'){
			message = xgov.raw_decode_message(dat,{secret:secret});
		}
		else if(crypto_scheme === 'NaCl-Sign-ed25519'){
			var sender_public_key = sender_address;
			var signed_message = decode_scheme(data[2]);
			if(typeof sender_public_key === 'string') sender_public_key = xgov.get_public_key_from_address(sender_public_key);
			message = nacl_crypto.sign.open(dat,sender_public_key);
		}
		if(message === false){
			if(!options.callback) return false; else return options.callback(null,false); 
		}
		if(param.raw){
			if(!options.callback) return message; else return options.callback(null,message); 
		}
		else{
			var buff_decoded = buffer_decode(message);
			if(!options.callback) return buff_decoded; else return options.callback(null,buff_decoded); 
		}
	};
	
	xgov. digest_structured_message = function(structured_message,options){
		if(docs) return {};
		try{
			var front_buffer_length = 4; //2^32 increased entropy front buffer in case of nonce collision
			if(!structured_message) return false;
			if(!options) options = {};
			var type = structured_message[front_buffer_length];
			if(options.type_must_be !== undefined && options.type_must_be !== type) return false;
			if(type === 0){
				var sha_strength = structured_message[front_buffer_length+1];
				var message = new Uint8Array(sha_strength);
				var sha_buffer_start = front_buffer_length + 2;
				var sha_payload_end = front_buffer_length + sha_strength + 2;
				for(var i = sha_buffer_start; i < sha_payload_end; ++i) message[i-sha_buffer_start] = structured_message[i];
				var signature_meta_buffer = new Uint8Array(structured_message.length - sha_payload_end);
				for(var i = sha_payload_end; i < structured_message.length; ++i) signature_meta_buffer[i-sha_payload_end] = structured_message[i];
				var signature_meta = JSON.parse(buffer_decode(signature_meta_buffer));
				var result = {
					type:type,
					message:message,
					sha_strength:sha_strength,
					signature_meta:signature_meta
				};
				if(options.callback) options.callback(null,result);
				return result;
			}
			else{
				//Unrecognized type;
			}
		}
		catch(e){
			if(options.callback) options.callback(e);
			return false;
		}
	};
	xgov. structured_message = function(param,options){
		if(docs) return {};
		try{
			if(!options) options = {};
			var front_buffer_length = 4; //2^32 increased entropy front buffer in case of nonce collision
			var structured_message;
			var type = param.type;
			var message = param.message;
			if(type === 0){
				var signature_meta = is_object(param.signature_meta) ? param.signature_meta : {};
					signature_meta = obj_neat_assign({},signature_meta); //IMPORTANT key order is important
				var signature_meta_buffer = buffer_encode(JSON.stringify(signature_meta));
				var sha_strength = param.sha_strength ? param.sha_strength : 0;
				structured_message = new Uint8Array(front_buffer_length + 1 + 1 + sha_strength + signature_meta_buffer.length); //msg_type_byte + sha_length_in_byte + sha_payload + signature_meta_data_payload
				var front_buffer = nacl_crypto.randomBytes(front_buffer_length);
				for(var i = 0; i < front_buffer_length; ++i) structured_message[i] = front_buffer[i];
				structured_message[front_buffer_length+0] = type; //message type data (0 == signature)
				structured_message[front_buffer_length+1] = sha_strength; //sha length data
				var sha_buffer_start = front_buffer_length + 2;
				var sha_payload_end = sha_strength + front_buffer_length + 2;
				for(var i = sha_buffer_start; i < sha_payload_end; ++i) structured_message[i] = message[i-sha_buffer_start];
				var metadata_payload_end = sha_payload_end + signature_meta_buffer.length;
				for(var i = sha_payload_end; i < metadata_payload_end; ++i) structured_message[i] = signature_meta_buffer[i-sha_payload_end];
				return resolve(structured_message,options);
			}
			else{
				//Unrecognized type;
			}
		}
		catch(e){
			if(options.callback) options.callback(e);
			return false;
		}
	};
	
	xgov. sign = function(txn,options){
		if(docs) return {};
		/*	ARG txn|stxn|sig|str = txn object || signed txn object to be added new signature || signature object itself || str converted to object {message:str} right away
				options = {callback:function, secret:string|Uint8Array(mandatory)}
			SYNC ONLY
			RETURNS false | signed_object[transaction_hash, txn_obj{rh:string(random_hash), t:int(time;ns)}, signatures[], time_signatures[]]
		*/
		if(!options) options = {};
		if(!txn) return resolve(false, options, new Error("No txn or stxn given as argument"));
		if(is_string(txn)) txn = {message:txn};
		if(!is_array(txn) && !is_object(txn)) return resolve(false, options, new Error("No valid txn/stxn given; must be object or array format "+JSON.stringify(txn)));
		var secret = options.secret;
		if(!secret){
			if(xgov_current_secret && (xgov_current_secret_fetch_exp == 0 || mtime() - xgov_current_secret_fetch_time <= xgov_current_secret_fetch_exp)){
				secret = xgov_current_secret;
			}
			else{
				return resolve(false, options, new Error("No secret given to sign"));
			}
		}
		
		var l = 'GAIA:UTS:ns', t = ntime();
		var sign_submission_time = options.time_sig ? true : false;
		var sig_supplied = false;
		var stxn_supplied = is_array(txn);
		var sig_tproof = null;
		if(stxn_supplied){
			//is first element txnhash or signature metadata?
			if(is_string(txn[0])){sig_supplied = false;}
			else{sign_submission_time = true; sig_supplied = true; stxn_supplied = false; sig_tcerts = txn[0].tcerts;}
		}
		
		var stxn = (stxn_supplied || sig_supplied) ? txn : null;
		if(stxn_supplied) txn = stxn[1];
		var signer_address = options.signer ? options.signer : xgov.credentials_from_secret(secret).address; 
		if(signer_address === xgov_sysgod_address){
			signer_address = 'SYSGOD';
			if_verbose(options, new Error("Signing as SYSGOD"));
		}
		var txnhash = (stxn && stxn_supplied) ? stxn[0] : null;
		
		//Check whether this transaction is already signed if stxn is supplied
		if(stxn_supplied){
			if(!sign_submission_time){
				var sig_arr = stxn[2];
				for(var i = 0; i < sig_arr.length; ++i){
					var sig_signer = sig_arr[i][1];
					if(send_address == sig_signer) 
						return resolve(false, options, new Error("Already signed by "+send_address));
				}
			}
			else{
				var sig_arr = stxn[3];
				for(var i = 0; i < sig_arr.length; ++i){
					var sig_signer = sig_arr[i][1][1];
					if(send_address == sig_signer) 
						return resolve(false, options, new Error("Already time-signed by "+send_address));
				}
			}
		}
		if(sig_supplied){
			var sig_arr = stxn[0].sts; //Signature time sig
			if(!is_array(sig_arr)) sig_arr = stxn[0].sts = [];
			for(var i = 0; i < sig_arr.length; ++i){
				var sig_signer = sig_arr[i][1][1];
				if(send_address == sig_signer) 
					return resolve(false, options, new Error("This signature is already timestamped by "+send_address));
			}
		}
		
		if(!sign_submission_time){
			if(stxn_supplied) txn = stxn[1]; //Original object vs signed object
			txn.rh = xgov.random_hash_b62(8); //random hash
			txn.t = ntime(); //nanosecond sig;
		}
		else{
			//Gaia earth, universal UNIX timestamp, in nanoseconds (precision up to ms accepted)
			if(sig_supplied){
				txn = {a:[
							stxn[1], //signer
							stxn[2], //signature nonce
							stxn[3] //signature encoded
						],
					l:l, t:t,
					z:xgov.neat_hash_b64(32) //Random signature hash: 64^32 (2^192) additional collision resistance in case of low entropy quickly repeated transactions
				};
			}
			else{
				txn = {
					id:txnhash, 
					l:l, t:t,
					z:xgov.neat_hash_b64(32) //Random signature hash: 64^32 (2^192) additional collision resistance in case of low entropy quickly repeated transactions
				};
			}
		}
		
		//key ordered copying
		//!!!!!IMPORTANT!!!! sha512("{a:1,b:1}") != sha512("{b:1,a:1}"), even though the two contain the same data.
		txn = obj_neat_assign({},txn);
		
		var str_form = JSON.stringify(txn);
		var sha512_sig = xgov.sha512(str_form,{raw_output:true});
		var sha_strength = (sig_supplied || !options.stronger_sha) ? 256/8 : 512/8; //64 vs. 32-Byte strength txn id (SHA256 vs. SHA512), default: 32-Byte
		if(stxn_supplied) sha_strength = buffer_decode(txnhash).length;
		var short_sig = new Uint8Array(sha_strength);
		for(var i = 0; i < sha_strength; ++i) short_sig[i] = sha512_sig[i];
		var calculated_txnhash = base62_encode(short_sig);
		
		stxn = (stxn_supplied || sig_supplied) ? stxn : 
			[
				calculated_txnhash, //stxn structure: 0 = txnhash (string)
				txn, 				//stxn structure: 1 = txn (object)
				[],					//stxn structure: 2 = signatures array of involved parties (signatures with timestamp signatures built in)
				[], 				//stxn structure: 3 = submission time signature array (master nodes signature)
				[],					//stxn structure: 4 = reviewers and authorizers who clears this transaction
				{},					//stxn structure: 5 = metadata (nodes, flags, marks, other info, etc.)
				{},					//stxn structure: 6 = additional follow-ups (e.g. later-added declassification decryption key of txn and metadata)
			];
		
		//Transaction object digested sha matches?
		if(!sign_submission_time && stxn_supplied && calculated_txnhash !== txnhash)
			return resolve(false, options, new Error("Transaction hash(id) does not match the transaction you are trying to sign"));
		
		//Copy flag
		if(options.copy && stxn_supplied) stxn = JSON.parse(JSON.stringify(stxn));
		
		//Structured signature message
		if(stxn_supplied){
			if(!options.signature_meta) options.signature_meta = {};
			options.signature_meta.l = l;
			options.signature_meta.t = t;
			options.signature_meta.z = xgov.neat_hash_b64(16); // 16 / 4 * 3 = 12 bytes, (2^96) additional collision resistance;
			//console.log(options.signature_meta.z);
		}
		var structured_message = xgov. structured_message({
			type:0, //signature
			message:short_sig,
			sha_strength:sha_strength,
			signature_meta:options.signature_meta
		});
		
		//Add me as signer
		var sig_arr = !sign_submission_time ? stxn[2] : stxn[3];
		if(!sign_submission_time){//txn object approval sign
			var sig = xgov.sign_message({message:structured_message, signer:signer_address, secret:secret, crypto_scheme:null},options);
			sig_arr.push(sig);
			if(options.signature_timestamp){
				xgov. submit_for_timestamp(sig, options);
				return stxn;
			}
		}
		else{//time sign, signature time sig or submission time sig
			var sig = xgov.sign_message({message:structured_message, signer:signer_address, secret:secret, crypto_scheme:null},options);
			if(sig_supplied) sig_arr = stxn[0].sts;
			var sig2 = [{l:txn.l,t:txn.t,z:txn.z},sig];
			sig_arr.push(sig2);
			if(sig_supplied) return sig2;
		}
		
		//Sign transaction AND current submission time?
		if(!sig_supplied && !sign_submission_time && options.also_sign_submission_time){
			options.time_sig = true;
			xgov.sign(stxn,options);
		}
		
		return stxn;
	};
	xgov. verify = function(stxn,options){
		if(docs) return {};
		/*	ARG stxn = signed object[]
				options = {callback:function}
			RETURNS true | false
		*/
		if(!options) options = {};
		if(!is_array(stxn))
			return resolve(false, options, new Error("Signed transaction must be of Array type."));
		if(!is_array(stxn[2]) || stxn[2].length == 0) 
			return resolve(false, options, new Error("No signature present or emptry signature array"));
		
		var txnhash = stxn[0];
		var sig_arr = stxn[2];
		var txnstr = (typeof stxn[1] === 'string') ? stxn[1] : JSON.stringify(stxn[1]);
		var sha512_sig = xgov.sha512(txnstr,{raw_output:true});
		var short_sig = new Uint8Array(64); //512 bit default
		for(var i = 0; i < short_sig.length; ++i) short_sig[i] = sha512_sig[i];
		
		//Verify txn signatures
		for(var i = 0;  i < sig_arr.length; ++i){
			var sig = sig_arr[i], signer = sig[1];
			if_verbose(options, new Error("TXN Signature index "+i+" : "+signer));
			
			//STS (submission time signature) must be presented (at least 1) if not signed by SYSGOD
			if(signer != "SYSGOD"){
				var sts = sig[0].sts;
				if((!is_array(sts) || sts.length == 0))
					return resolve(false, options, 
						new Error("STS Signature not supplied for TXN index "+i));
				var a = [sig[1],sig[2],sig[3]]; //Immutable signature part
				var sts_short_sig = new Uint8Array(64);
				for(var j = 0; j < sts.length; ++j){
					var stsobj = sts[i];
					var ststxnobj = stsobj[0];
					var stssigpart = stsobj[1];
					var ststxnstr = JSON.stringify({a:a,l:ststxnobj.l,t:ststxnobj.t,z:ststxnobj.z}); //alphabetical ORDER IMPORTANT;
					var sts_sha512_sig = xgov.sha512(ststxnstr,{raw_output:true});
					for(var k = 0; k < 64; ++k) sts_short_sig[k] = sts_sha512_sig[k];
					var decoded = xgov.digest_structured_message(xgov.decode_message({data:stssigpart, raw:true}),{type_must_be:0});
					if(decoded === null || decoded === false)
						return resolve(false, options, 
							new Error("STS validation failed: "+JSON.stringify(stsobj)));
					var dmsg = decoded.message, dmsglen = dmsg.length;
					if(dmsglen < 32)
						return resolve(false, options, 
							new Error("STS Verification SHA length does not match. (min. 32 byte signature)"));
					for(var k = 0; k < dmsglen; ++k){
						if(dmsg[k] !== sts_short_sig[k]){
							return resolve(false, options, 
								new Error("STS Verification SHA does not match. ("+JSON.stringify(dmsg)+" vs. "+JSON.stringify(sts_short_sig)+")"));
						}
					}
				}
				if_verbose(options, new Error("All STS Verification signatures (count="+sts.length+") for signature index ("+i+") are verified."));
			}
			//
			var decoded = xgov.digest_structured_message(xgov.decode_message({data:sig, raw:true}),{type_must_be:0});
			if(decoded === null || decoded === false)
				return resolve(false, options, 
					new Error("TXN Signature validation failed: "+JSON.stringify(sig)));
			var dmsg = decoded.message, dmsglen = dmsg.length;
			if(dmsglen < 32)
				return resolve(false, options, 
					new Error("TXN Verification SHA length does not match. (min. 32 byte signature)"));
			for(var j = 0; j < dmsglen; ++j){
				if(dmsg[j] !== short_sig[j]){
					return resolve(false, options, 
						new Error("TXN Verification SHA does not match. ("+JSON.stringify(dmsg)+" vs. "+JSON.stringify(short_sig)+")"));
				}
			}
		}
		
		if_verbose(options, new Error("All transaction signatures (count="+sig_arr.length+") are verified."));
		
		//Verify time signatures of submission
		var time_sig_arr = stxn[3]; 
		if(!is_array(time_sig_arr) || time_sig_arr.length == 0){
			//No time sig? default verify true when all signatures are valid
			if_verbose(options, new Error("Submission time signature not present: by default verified true."));
			return resolve(true, options);
		}
		for(var i = 0;  i < time_sig_arr.length; ++i){
			var tsigobj = time_sig_arr[i];
			//submission time object & SHA part
			var subm_txn = tsigobj[0];
			var txnstr = JSON.stringify({id:txnhash,l:subm_txn.l,t:subm_txn.t,z:subm_txn.z}); //alphabetical ORDER IMPORTANT;
			var sha512_sig = xgov.sha512(txnstr,{raw_output:true});
			for(var j = 0; j < 64; ++j) short_sig[j] = sha512_sig[j];
			//time signature part
			var sig = tsigobj[1], signer = sig[1];
			if_verbose(options, new Error("Submission time signature index "+i+", signer = "+signer));
			var decoded = xgov.digest_structured_message(xgov.decode_message({data:sig, raw:true}),{type_must_be:0});
			if(decoded === null || decoded === false)
				return resolve(false, options, 
					new Error("Submission time signature validation failed: "+JSON.stringify(sig)));
			var dmsg = decoded.message, dmsglen = dmsg.length;
			if(dmsglen < 32)
				return resolve(false, options, 
					new Error("Submission time signature SHA length does not match. (min. 32 byte signature)"));
			for(var j = 0; j < dmsglen; ++j){
				if(dmsg[j] !== short_sig[j]){
					return resolve(false, options, 
						new Error("Submission time signature SHA does not match. ("+JSON.stringify(dmsg)+" vs. "+JSON.stringify(short_sig)+")"));
				}
			}
		}
		
		if_verbose(options, new Error("All time signatures (count="+time_sig_arr.length+") are verified."));
		return true;
	};
	xgov. timestamp = function(sig,options){
		if(docs) return {};
		if(!options) options = {};
		if(!is_array(sig) || !is_object(sig[0])) return false;
		if(!options.secret && !xgov_timestamper_secret && !xgov_sysgod_key) return false;
		if(!options.secret) options.secret = xgov_timestamper_secret;
		if(!options.secret) options.secret = xgov_sysgod_key;
		return xgov.sign(sig,options);
	};
	xgov. sign_message = function(param,options){
		if(docs) return {};
		var message = param.message;
		var my_secret = param.secret;
		
		var encoding_codec = param.codec; if(!encoding_codec) encoding_codec = 'b62';
		var encode_scheme;
		if(encoding_codec === 'b62') encode_scheme = base62_encode;
		else if(encoding_codec === 'b64') encode_scheme = base64_encode;
		else if(encoding_codec === 'hex') encode_scheme = hex_encode;
		
		var crypto_scheme = param.crypto_scheme ? param.crypto_scheme : 'NaCl-Box-x25519';
		
		if(typeof message == 'string') message = buffer_encode(message);
		else if(!(message instanceof Uint8Array)) message = buffer_encode(JSON.stringify(message));
		
		var encoded_arr, darr;
		if(crypto_scheme === 'NaCl-Box-x25519'){
			encoded_arr = xgov.raw_encode_message({
				message:message,
				nonce:null,
				recv_pubkey:xgov_public_public_key, 
				secret:my_secret,
				signer:param.signer,
			});
			darr = [
				{enc:encoding_codec, crypto:crypto_scheme}, //0 meta, encoding, crypto_scheme etc.
				param.signer, //1 Signer
				encode_scheme(encoded_arr[2]), //2 Nonce
				encode_scheme(encoded_arr[3]), //3 Data
			];
		}
		else if(crypto_scheme === 'NaCl-Sign-ed25519'){
			if(typeof my_secret === 'string') my_secret = base62_decode(my_secret);
			var secret_64_keypair = nacl_crypto.sign.keyPair.fromSeed(my_secret); //make 64 byte secret from 32 byte secret;
			var secret_key = secret_64_keypair.secretKey;
			//TODO: match public key to signer, if not return error
			encoded_arr = nacl_crypto.sign(message,secret_key); //64 byte signature
			darr = [
				{enc:encoding_codec, crypto:crypto_scheme}, //0 meta, encoding, crypto_scheme etc.
				param.signer, //1 Signer
				encode_scheme(encoded_arr), //2 Signature Data
			];
		}
		if(!darr || !encoded_arr || !is_array(encoded_arr)){
			return resolve(false,options,new Error("Could not sign the message: (encoding="+encoding_codec+", crypto_scheme="+crypto_scheme+")"));
		}
		return resolve(darr,options);
	};
	xgov. find_signers = function(stxn,options){
		if(docs) return {};
		/*	ARG stxn = signed object[]
				options = {callback:function}
			RETURNS true | false
		*/
		if(!options) options = {};
		
		if(!is_array(stxn))
			return resolve(false, options, new Error("Signed transaction must be of Array type."));
		if(!options.signers && !options.targets && !options.signer && !options.target)
			return resolve(false, options, new Error("Target signers argument (options.signers|targets|signer|target) not found."));
		if(!is_array(stxn[2]) || stxn[2].length == 0) 
			return resolve(false, options, new Error("No signature present or emptry signature array"));
		
		var target_signatures = [];
		var target_signers;
		if(is_array(options.signers)) target_signers = options.signers;
		else if(is_array(options.targets)) target_signers = options.targets;
		else if(is_string(options.signer)) target_signers = [options.signer];
		else if(is_string(options.target)) target_signers =[options.target];
		else return resolve(false, options, new Error("Target signers not present or type mismatch."));
		
		var sig_arr = stxn[2];
		for(var h = 0; h < target_signers.length; ++h){
			var target_signer = target_signers[h];
			for(var i = 0;  i < sig_arr.length; ++i){
				var sig = sig_arr[i], signer = sig[1];
				if(signer === target_signer || sender_by_address[signer] === target_signer || sender_by_name[signer] === target_signer){
					target_signatures[h] = sig;
					if_verbose(options, new Error("Target signer "+signer+" found"));
				}
			}
		}
		if(target_signatures.length != target_signers.length)
			return resolve(false, options, new Error("Not all signers are found. "+JSON.stringify(target_signatures)+" vs. "+JSON.stringify(target_signers)));
		var all_found = true;
		for(var i = 0; i < target_signatures.length; ++i){if(!is_array(target_signatures[i])){all_found=false; break;}}
		if(!all_found)
			return resolve(false, options, new Error("Not all signers are found. "+JSON.stringify(target_signatures)+" vs. "+JSON.stringify(target_signers)));
		return target_signatures;
	};
	xgov. first_signature = function(stxn,options){
		if(docs) return {};
		return stxn[2][0];
	};
	xgov. add_timestamp = function(param,options){
		if(docs) return {};
		if(!options) options = {};
		var sig = param.sig;
		var stamp = param.timestamp;
		var stamper_address = stamp[1][1];
		if(!sig[0].sts) sig[0].sts = [];
		var sig_arr = sig[0].sts; //Signature time sig
		for(var i = 0; i < sig_arr.length; ++i){
			var prev_stamper = sig_arr[i][1][1];
			if(stamper_address == prev_stamper) 
				return resolve(false, options, new Error("This signature is already timestamped by "+stamper_address));
		}
		sig[0].sts.push(stamp);
		return resolve(true, options);
	};
	xgov. secretbox = function(param,options){
		if(!options) options = {};
		var buffer = (param.buffer instanceof Uint8Array) ? param.buffer : base62_decode(param.buffer);
		var nonce = (param.nonce instanceof Uint8Array) ? param.nonce : base62_decode(param.nonce);
		var secret = (param.secret instanceof Uint8Array) ? param.secret : base62_decode(param.secret);
		var res = nacl_crypto.secretbox(buffer, nonce, secret);
		return resolve(res,options);
	}
	xgov. secretbox_open = function(param,options){
		if(!options) options = {};
		var buffer = (param.buffer instanceof Uint8Array) ? param.buffer : base62_decode(param.buffer);
		var nonce = (param.nonce instanceof Uint8Array) ? param.nonce : base62_decode(param.nonce);
		var secret = (param.secret instanceof Uint8Array) ? param.secret : base62_decode(param.secret);
		var res = nacl_crypto.secretbox.open(buffer, nonce, secret);
		return resolve(res,options);
	}
	xgov. secure_password_format = function(param,options){
		var email = param.email.toLowerCase().trim();
		var eh = xgov.sha512(email,{raw_output:true});
		var security_level = param.security_level ? parseInt(param.security_level) : 2;
		if(isNaN(security_level)) security_level = 2;
		if(security_level < 1) security_level = 1;
		var iteration = Math.pow(2,security_level-1)*(333333+(1024*eh[0]+256*eh[1]+64*eh[2]+16*eh[3]+4*eh[4]+1*eh[5]));
		var result = {
			email:email,
			security_level:security_level,
			iteration:iteration
		};
		return resolve(result,options);
	}
	xgov. password_digest = function(pw,options){
		if(!options) options = {};
		if(is_object(pw) && pw.salt){options.salt = pw.salt; pw = pw.password;}
		var salt = options.salt; if(!salt) salt = '_xgov_pw_prehash_salt'; //!!!AMDNT!!! : DO NOT CHANGE THE SALT
		pw = pw + salt;
		var pw_bytes = new Uint8Array(32);
		var pw_nonce = new Uint8Array(24);
		var pw_sha512 = xgov.sha512(pw,{raw_output:true});
		for(var i = 0; i < 19; ++i) pw_sha512 = nacl_crypto.hash(pw_sha512); //!!!AMDNT!!! DO NOT CHANGE sha iteration of 19
		for(var i = 0; i < 32; ++i) pw_bytes[i] = pw_sha512[i];
		for(var i = 32; i < 32+24; ++i) pw_nonce[i-32] = pw_sha512[i-32];
		return resolve({
			nonce : options.raw ? pw_nonce : base62_encode(pw_nonce),
			secret : options.raw ? pw_bytes : base62_encode(pw_bytes)
		},options);
	}
	
	xgov. as_god = function(t,options){
		if(docs) return {};
		if(!options) options = {};
		if(!t || isNaN(t)) t = xgov_sysgod_key_fetch_exp_default;
		xgov.retrieve_secret({name:'sysgod', prompt:true},{callback:function(e,secret){
			if(e){if(options.callback) options.callback(e); return;}
			xgov_sysgod_key = secret;
			xgov_sysgod_key_fetch_time = mtime();
			xgov_sysgod_key_fetch_exp = t;
			if(options.load_as_current) xgov. current_secret_load(secret);
			if(options.callback) options.callback(null,true);
		}});
	};
	xgov. as_normal = function(){
		if(docs) return {};
		if(xgov_current_secret == xgov_sysgod_key){
			xgov_current_secret = null;
			xgov_current_secret_fetch_time = 0;
		}
		xgov_sysgod_key = null;
		xgov_sysgod_key_fetch_time = 0;
		xgov_sysgod_key_fetch_exp = xgov_sysgod_key_fetch_exp_default;
	};
	xgov. sign_as_god = function(obj,options){
		if(docs) return {};
		if(!options) options = {};
		if(xgov_sysgod_key && (mtime() - xgov_sysgod_key_fetch_time <= xgov_sysgod_key_fetch_exp || xgov_sysgod_key_fetch_exp == 0)){
			options.secret = xgov_sysgod_key;
			return xgov.sign(obj, options);
		}
		else{
			var exp_time = options.expire_in ? options.expire_in : 0; //3 second session default
			xgov.as_god(0,function(e,data){
				if(e){if(options.callback) options.callback(e); return;}
				options.secret = xgov_sysgod_key;
				var signed = xgov.sign(obj, options);
				if(options.callback) options.callback(null,signed);
			});
		}
	};
	
	xgov. store_secret = function(param,options){
		if(docs) return {};
		if(!param) param = {};
		var name = param.name;
		var secret = param.secret;
		var password = param.password;
		var message = param.message ? param.message 
			: "You are about to encrypt and store an account secret on this device. (ONLY do this on a trusted personal device)";
		var affirmative = param.affirmative ? param.affirmative : 'STORE';
		var affirmative_ico = param.affirmative_ico ? param.affirmative_ico : 'https://s3.amazonaws.com/jvs-static/img/real_lock_ico2.png';
		if(!is_nodeJS_master && (!prompt || !prompt.start || !prompt.get))
			return resolve(false, options, new Error('Prompt handler is not set.'),true);
		var name_prompt_needed = (!name || name.length < 3);
		var secret_prompt_needed = (!secret || (secret.length != 42 && secret.length != 43));
		var password_prompt_needed = (!password || password.length < 8);
		var schema = {
			properties:{},
			affirmative_ico:affirmative_ico,
			affirmative:affirmative,
			message:message
		};
		if(is_nodeJS_master) console.log(message);
		if(name_prompt_needed) schema.properties.name = { 
			required: true,
			pattern: /^[a-zA-Z0-9\-\_]+$/,
			message: 'Name must be alphanumeric optionally with hyphen {0-9,A-Z,a-z,hyphen}.', 
			label:'Nickname (Do NOT use account address)'
		};
		if(secret_prompt_needed) schema.properties.secret = { 
			required: true,
			hidden: true, 
			pattern: /^[a-zA-Z0-9]+$/, 
			message: 'Secret must be base62 encoded string {0-9,A-Z,a-z}.',
			label:'Secret (42~43 characters long, base62 encoded)'
		};
		schema.properties.password = { 
			required: true, 
			hidden: true,
			label:'Password (encrypts the secret code, 8-char min.)' 
		};
		var response_handled = false;
		var response_handler = function(e,result){
			try{
				if(response_handled) return; response_handled = true;
				if(e) return resolve(false, options, e);
				if(secret_prompt_needed){ secret = result.secret; if(secret.length != 42 && secret.length != 43)
					return resolve(false, options, new Error('Input secret length must be 42~43 characters long, given '+secret.length+' characters'),true);
				}
				if(name_prompt_needed){ name = result.name; if(result.name.length < 3) 
					return resolve(false, options, new Error('Input name length must be at lest 3 characters long, given '+name.length+' characters'),true);
				}
				if(password_prompt_needed){ password = result.password; if(password.length < 8) 
					return resolve(false, options, new Error('Input password length must be at least 8 characters long, given '+password.length+' characters'),true);
				}
				var pw_bytes = new Uint8Array(32);
				var pw_nonce = new Uint8Array(24);
				if(!(password instanceof Uint8Array)) password = buffer_encode(password);
				var pw_sha512 = xgov.sha512_raw(password);
				for(var i = 0; i < 32; ++i) pw_bytes[i] = pw_sha512[i];
				for(var i = 32; i < 32+24; ++i) pw_nonce[i-32] = pw_sha512[i-32];
				var content = nacl_crypto.secretbox(buffer_encode(secret), pw_nonce, pw_bytes);
				var content_str = base62_encode(content);
				if(is_nodeJS_master){
					if(!fs.existsSync(xgov_basepath)) fs.mkdirSync(xgov_basepath);
					if(!fs.existsSync(xgov_basepath+"secrets")) fs.mkdirSync(xgov_basepath+"secrets");
					if(param.async){
						fs.writeFile(xgov_basepath+'secrets/'+name, content_str, function(e){
							if(e) return resolve(false, options, e);
							console.log("Successfully encrypted and stored secret with name_key '"+name+"' in "+(xgov_basepath+'secrets/'+name)+"");
							return resolve(true, options);
						}); 
					}
					else{
						var res = fs.writeFileSync(xgov_basepath+'secrets/'+name, content_str); 
						console.log("Successfully encrypted and stored secret with name_key '"+name+"' in "+(xgov_basepath+'secrets/'+name)+"");
						return resolve(true, options);
					}
				}
				else{
					if(is_xgov_webnode){
						if(!options.callback)
							return resolve(false, options, new Error("Webnode store_secret must be async in nature"),true);
						xgov_db.put_data(xgov_basepath+'secrets/'+name, content_str, function(e,result){
							if(e) return resolve(false, options, e);
							return resolve(true, options);
						});
					}
					else{
						localStorage.setItem(xgov_basepath+'secrets/'+name, content_str);
						if(param.async)
							return resolve(true, options);
						else
							return resolve(true, options);
					}
				}
				return true;
			}
			catch(e){return resolve(false, options, e);}
		};
		if(name_prompt_needed || secret_prompt_needed || password_prompt_needed){
			if(!param.prompt){
				var emsg = 'param.prompt flag not received and supplied inputs are insufficient. (name_needed='
							+(name_prompt_needed?1:0)+', secret_needed='+(secret_prompt_needed?1:0)+', password_needed='+(password_prompt_needed?1:0);
				return resolve(false, options, new Error(emsg),true);
			}
			if(is_nodeJS_master){
				prompt.message = colors.cyan("store_secret"); 
				prompt.delimiter = ": ";
			}
			prompt.start();
			prompt.get(schema,function(e,result){
				try{response_handler(e,result);}
				catch(e){return resolve(false, options, e);}
			});
		}
		else{
			return response_handler(null,{});
		}
	};
	xgov. retrieve_secret = function(param,options){
		if(docs) return {};
		if(!param) param = {};
		var name = param.name;
		var secret = param.secret;
		var password = param.password;
		var message = param.message ? param.message 
			: (name ? "Accessing secret of the name_key '"+name+"'; enter the password to unlock." 
				: "Accessing secret; enter the name_key and the password to unlock.");
		var affirmative = param.affirmative ? param.affirmative : 'UNLOCK';
		var affirmative_ico = param.affirmative_ico ? param.affirmative_ico : 'https://s3.amazonaws.com/jvs-static/img/real_lock_ico2.png';
		if(!is_nodeJS_master && (!prompt || !prompt.start || !prompt.get))
			return resolve(false, options, new Error('Prompt handler is not set.'),true);
		var name_prompt_needed = (!name || name.length < 3);
		var password_prompt_needed = (!password || password.length < 6);
		var schema = {
			properties:{},
			affirmative_ico:affirmative_ico,
			affirmative:affirmative,
			message:message
		};
		if(is_nodeJS_master && (name_prompt_needed || password_prompt_needed)) console.log(message);
		if(name_prompt_needed) schema.properties.name = { 
			required: true,
			pattern: /^[a-zA-Z0-9\-\_]+$/,
			message: 'Name must be alphanumeric optionally with hyphen {0-9,A-Z,a-z,hyphen}.', 
			label:'Access Nickname'
		};
		if(password_prompt_needed) schema.properties.password = { 
			required: true, 
			hidden: true,
			label:'Encryption Password' 
		};
		var response_handled = false;
		var response_handler = function(e,result){
			try{
				if(response_handled) return; response_handled = true;
				if(e) return resolve(false, options, new Error("Access nickname '"+name+"' could not be fetched: "+e.message),true);
				if(name_prompt_needed){ name = result.name; if(result.name.length < 3) 
					return resolve(false, options, new Error('Input name length must be at lest 3 characters long, given '+name.length+' characters'),true);
				}
				if(password_prompt_needed){ password = result.password; if(password.length < 6) 
					return resolve(false, options, new Error('Input password length must be at least 6 characters long, given '+password.length+' characters'),true);
				}
				var decrypt_func = function(content,key){
					if(!content || !key) return false;
					var pw_bytes = new Uint8Array(32);
					var pw_nonce = new Uint8Array(24);
					var pw_sha512 = xgov.sha512(key,{raw_output:true});
					for(var i = 0; i < 32; ++i) pw_bytes[i] = pw_sha512[i];
					for(var i = 32; i < 32+24; ++i) pw_nonce[i-32] = pw_sha512[i-32];
					content = base62_decode(content);
					var decoded = nacl_crypto.secretbox.open(content, pw_nonce, pw_bytes);
					if(!decoded) return false;
					var decoded_str = buffer_decode(decoded);
					return decoded_str;
				}
				if(is_nodeJS_master){
					if(param.async){
						fs.readFile(xgov_basepath+'secrets/'+name, {encoding:'utf8'}, function(e,content){
							if(e) return resolve(false, options, e);
							var decoded = decrypt_func(content,password);
							if(!decoded) return resolve(false, options, new Error("Could decode the secret with given password '"+name+"'"));
							return resolve(decoded, options);
						}); 
					}
					else{
						var content = fs.readFileSync(xgov_basepath+'secrets/'+name, {encoding:'utf8'});
						if(!content) return resolve(false, options, new Error("Could not find the registered name_key '"+name+"'"));
						var decoded = decrypt_func(content,password);
						if(!decoded) return resolve(false, options, new Error("Could decode the secret with given password '"+name+"'"));
						return resolve(decoded, options);
					}
				}
				else{
					if(is_xgov_webnode){
						if(!options.callback) return resolve(false, options, new Error("Webnode store_secret must be async in nature"), true);
						xgov_db.get_data(xgov_basepath+'secrets/'+name, function(e,result){
							if(e) return resolve(false, options, e);
							var decoded = decrypt_func(result,password);
							if(!decoded) return resolve(false, options, new Error("Cannot decrypt the secret with the given password"));
							return resolve(decoded, options);
						});
					}
					else{
						var encoded = localStorage.getItem(xgov_basepath+'secrets/'+name);
						if(!encoded)
							return resolve(false, options, new Error("Access nickname '"+name+"' is not found on thie device."),true);
						if(param.async){
							var decoded = decrypt_func(encoded,password);
							if(!decoded) return resolve(false, options, new Error("Cannot decrypt the secret with the given password"));
							return resolve(decoded, options);
						}
						else{
							var decoded = decrypt_func(encoded,password);
							if(!decoded) return resolve(false, options, new Error("Cannot decrypt the secret with the given password"));
							return resolve(decoded, options);
						}
					}
				}
				return true;
			}
			catch(e){return resolve(false, options, e);}
		};
		if(name_prompt_needed || password_prompt_needed){
			if(!param.prompt){
				var emsg = 'param.prompt flag not received and supplied inputs are insufficient. (name_needed='
							+(name_prompt_needed?1:0)+', password_needed='+(password_prompt_needed?1:0);
				return resolve(false, options, new Error(emsg),true);
			}
			if(is_nodeJS_master){
				prompt.message = colors.cyan("retrieve_secret"); 
				prompt.delimiter = ": ";
			}
			prompt.start();
			prompt.get(schema,function(e,result){
				try{response_handler(e,result);}
				catch(e){return resolve(false, options, e);}
			});
		}
		else{
			return response_handler(null,{});
		}
	};
	xgov. prompt = function(param,options){
		var affirmative_ico = param.affirmative_ico ? param.affirmative_ico : null;
		var affirmative = param.affirmative ? param.affirmative : 'YES';
		var message = param.message ? param.message : 'Input Prompt';
		var properties = param.properties ? JSON.parse(JSON.stringify(param.properties)) : {
			required: true, 
			//hidden: true,
			label:'Input Parameter'
		};
		var schema = {
			properties:properties,
			affirmative_ico:affirmative_ico,
			affirmative:param.affirmative,
			type:param.type,
			message:message
		};
		var response_handled = false;
		var response_handler = function(e,result){
			try{
				if(response_handled) return;
				response_handled = true;
				var clean_result = {};
				if(result){
					for(var p in properties) clean_result[p] = result[p];
					if(result.action) clean_result.action = result.action;
				}
				return resolve(clean_result, options);
			}
			catch(e){
				console.log(e);
				return resolve(false, options, e);
			}
		};
		if(is_nodeJS_master){
			prompt.message = colors.cyan("store_secret"); 
			prompt.delimiter = ": ";
		}
		prompt.start();
		prompt.get(schema,function(e,result){
			try{response_handler(e,result);}
			catch(e){return resolve(false, options, e);}
		});
	}
	
	xgov. pwxor = function(param,options){
		if(!param) param = {};
		if(!options) options = {};
		var data = param.data;
		var pw = param.password; if(!pw && xgov_default_pwxor_password) pw = xgov_default_pwxor_password;
		var data_bytes = options.raw_input ? data : base62_decode(data);
		var pwxor_cypher = xgov.sha512(pw+"",{raw_output:true});
		for(var i = 0; i < data_bytes.length; ++i) data_bytes[i] ^= pwxor_cypher[i%64];
		if(options.raw_output) return resolve(data_bytes,options);
		return resolve(base62_encode(data_bytes),options);
	}
	xgov. pwxor_password_load = function(pw,options){
		xgov_default_pwxor_password = pw;
		return resolve({},options);
	}
	
	xgov. sha512 = function(str,options){
		if(docs) return {};
		if(!options) options = {};
		var raw_input = options.raw_input;
		var raw_output = options.raw_output;
		if(!raw_output){
			var encode_function;
			if(raw_output == 'b62') encode_function = base62_encode;
			else if(raw_output == 'b64') encode_function = base64_encode;
			else encode_function = hex_encode;
			if(!raw_input) return encode_function(nacl_crypto.hash(buffer_encode(str)));
			else return encode_function(nacl_crypto.hash(str));
		}
		else{
			if(!raw_input) return nacl_crypto.hash(buffer_encode(str));
			else return nacl_crypto.hash(str);
		}
	};
	xgov. sha512_raw = function(buffer,options){
		if(docs) return {};
		if(!options) options = {};
		return nacl_crypto.hash(buffer);
	};
	xgov. sha512_iterate = function(param,options){
		var holder = param.hash;
		if(!(holder instanceof Uint8Array)){
			if(is_array(holder)){
				var holder2 = new Uint8Array(holder.length);
				var hlen = holder.length;
				for(var i = 0; i < hlen; ++i) holder2[i] = holder[i];
				holder = holder2;
			}
			else if(!param.encoding){holder = buffer_encode(holder);}
			else if(param.encoding == 'base62') holder = base62_decode(holder);
		}
		var batch_size = param.batch_size ? parseInt(param.batch_size) : 30000;
		if(isNaN(batch_size) || batch_size < 10000) batch_size = 10000;
		var count = param.count, i = 0;
		if(param.type === "RKM_search"){
			var minimum = param.minimum, i = 0, found = false,
				match_byte = param.match_byte, check_byte = param.check_byte, map_byte = param.map_byte;
			var match_byte0 = (map_byte === 2) ? match_byte : match_byte[0];
			var match_byte1 = (map_byte === 2) ? match_byte : match_byte[1];
			var match_byte2 = (map_byte === 2) ? match_byte : match_byte[2];
			var minimum_passed = false;
			var iterator = setInterval(function(){
				try{
					if(!minimum_passed){
						for(var j = 0; j < batch_size; ++j){
							++i; holder = nacl_crypto.hash(holder);
							if(i >= minimum){minimum_passed = true; break;}
						}
					}
					else{
						for(var j = 0; j < batch_size; ++j){
							++i; holder = nacl_crypto.hash(holder);
							if(i >= minimum){
								if(map_byte === 2){
									if(holder[0] === match_byte && holder[1] === check_byte){
										found = true; break;
									}
								}
								else if(map_byte === 3){
									if(holder[0] === match_byte0 && holder[1] === match_byte1 && holder[2] === check_byte){
										found = true; break;
									}
								}
								else if(map_byte === 4){
									if(holder[0] === match_byte0 && holder[1] === match_byte1 && holder[2] === match_byte2 && holder[3] === check_byte){
										found = true; break;
									}
								}
								else if(map_byte === 1){
									if(holder[0] === check_byte){
										found = true; break;
									}
								}
							}
						}
					}
					if(!found) return progress_update({count:i,arg:param},options);
					clearInterval(iterator); if(!options.raw_output) holder = base62_encode(holder);
					return resolve({iteration:i,hash:holder,arg:param},options);
				}
				catch(e){clearInterval(iterator); return resolve(false,options,e);}
			},0);
		}
		else if(!param.type || param.type === "iterate"){
			var i = 0;
			var count = param.count; if(!count && param.iteration) count = param.iteration;
			if(isNaN(count) || count < 1) count = 1;
			var iterator = setInterval(function(){
				try{
					for(var j = 0; i < count && j < batch_size; ++j){
						++i; holder = nacl_crypto.hash(holder);
					}
					if(i < count) return progress_update({count:i,target:count,arg:param},options);
					clearInterval(iterator); if(!options.raw_output) holder = base62_encode(holder);
					return resolve({hash:holder,arg:param},options);
				}
				catch(e){clearInterval(iterator); return resolve(false,options,e);}
			},0);
		}
		else{
			return resolve(false,options,new Error("Unknown SHA-512 Operation: "+param.type));
		}
	}
	xgov. hex_encode = function(buffer,options){
		if(docs) return {};
		return hex_encode(buffer);
	};
	xgov. hex_decode = function(str,options){
		if(docs) return {};
		return hex_decode(str);
	};
	xgov. buffer_encode = function(str,options){
		if(docs) return {};
		return buffer_encode(str);
	};
	xgov. buffer_decode = function(buffer,options){
		if(docs) return {};
		return buffer_decode(buffer);
	};
	xgov. base30_encode = function(buffer,options){
		if(docs) return {};
		return base30_encode(buffer);
	};
	xgov. base30_decode = function(str,options){
		if(docs) return {};
		return base30_decode(str);
	};
	xgov. base62_encode = function(buffer,options){
		if(docs) return {};
		return base62_encode(buffer);
	};
	xgov. base62_decode = function(str,options){
		if(docs) return {};
		return base62_decode(str);
	};
	xgov. base64_encode = function(buffer,options){
		if(docs) return {};
		return base64_encode(buffer);
	};
	xgov. base64_decode = function(str,options){
		if(docs) return {};
		return base64_decode(str);
	};
	xgov. random_hash_raw = function(length,options){
		if(docs) return {};
		if(!length) length = 32;
		return nacl_crypto.randomBytes(length);
	};
	xgov. random_hash_b62 = function(length,options){
		if(docs) return {};
		if(!length) length = 32;
		return base62_encode(nacl_crypto.randomBytes(length)).substr(0,length);
	};
	xgov. random_hash_b30 = function(length,options){
		if(docs) return {};
		if(!length) length = 32;
		return base30_encode(nacl_crypto.randomBytes(length)).substr(0,length);
	};
	xgov. neat_hash_b64 = function(length,options){
		if(docs) return {};
		//length must be multiple of 4;
		if(!length) length = 4;
		if(length % 4 !== 0) length += 4 - (length % 4);
		var rand_bytes = nacl_crypto.randomBytes((length/4*3));
		return base64_encode(rand_bytes);
	}
	xgov. sanitize_empty_string = function(a,options){
		if(docs) return {};
		return sanitize_empty_string(a,options);
	}
	
	xgov. master_node_connection_set = function(con,options){
		if(docs) return {};
		master_node_connection = con;
		var arr = master_node_connection_onloads;
		for(var i = 0; i < arr.length; ++i){
			var a = arr[i];
			if(a && a.func){
				a.func(null,true); if(!a.options.forever) arr[i] = null;
			}
		}
		arr = arr.filter(function(n){return n !== null}); 
		return resolve(true,options);
	};
	xgov. master_node_connection_onload = function(func,options){
		if(docs) return {};
		if(!options) options = {};
		if(master_node_connection){
			func(null,true);
			if(!options.forever) return;
		}
		if(!options.max_wait) options.max_wait = 30000;
		var arr = master_node_connection_onloads;
		var idx = arr.length;
		arr.push({func:func, options:options});
		if(options.max_wait){
			//TODO
		}
		return resolve(idx,options);
	};
	xgov. set_prompt_handler = function(handler,options){
		if(docs) return {};
		prompt = handler;
	};
	xgov. set_record_handler = function(handler,options){
		if(docs) return {};
		record_handler = handler;
		if(!codebase_initialized) xgov.codebase_initialize();
	};
	xgov. set_ui_handler = function(handler,options){
		if(docs) return {};
		ui_handler = handler;
	};
	
	xgov. submit = function(signed_txn,options){
		if(docs) return {};
		if(!options) options = {};
		if(!master_node_connection) throw new Error('Submitting requires a master node link to be established first.');
		if(!signed_txn) throw new Error('The submitted transaction is empty.');
		var handled = false;
		master_node_connection.send({
			action:"submit", kind:"xgov",
			signed_txn:signed_txn,
			callback:function(e,data){
				if(handled) return; handled = true;
				if(options.callback) options.callback(e,data);
			}
		});
	};
	xgov. submit_for_timestamp = function(sig,options){
		if(docs) return {};
		if(!options) options = {};
		if(!master_node_connection) return resolve(false, options, new Error("Master node not found for signature timestamping"));
		var handled = false;
		master_node_connection.send({
			action:"timestamp", kind:"xgov",
			signature:sig,
			callback:function(e,data){
				if(handled) return; handled = true;
				if(e) return resolve(false, options, e);
				if(options.auto_add){
					if(!sig[0].sts) sig[0].sts = [];
					sig[0].sts.push(data); //push timestamp sign
				}
				return resolve(data, options);
			}
		});
	}; 
	xgov. hotblock_exempt = function(signed_txn,options){
		if(docs) return {};
		if(!options) options = {};
		if(!master_node_connection) return resolve(false, options, new Error("Master node not found."));
		var handled = false;
		master_node_connection.send({
			action:"hotblock_exempt", kind:"connection",
			signed_txn:signed_txn,
			callback:function(e,data){
				if(handled) return; handled = true;
				if(e) return resolve(false, options, e);
				return resolve(data, options);
			}
		});
	};
	xgov. request_pwxor = function(param,options){
		if(docs) return {};
		if(!options) options = {};
		if(!master_node_connection) return resolve(false, options, new Error("Master node not found."));
		var handled = false;
		master_node_connection.send({
			action:"pwxor", kind:"xgov",
			data:param.data,
			salt:param.salt,
			callback:function(e,data){
				if(handled) return; handled = true;
				if(e) return resolve(false, options, e);
				return resolve(data, options);
			}
		});
	}; 
	
	xgov. codebase_initialize = function(param,options){
		if(docs) return {};
		if(!record_handler) return resolve(false, options, new Error('Record handler must be set before initializing the codebase.'));
		if(!record_handler.codebase_initialize) return resolve(false, options, new Error('Record handler does not offer codebase functions'));
		record_handler.codebase_initialize({},{callback:function(e,data){
			if(e) return resolve(false, options, new Error('Could not fetch codebase records from the data handlers.'));
			var cb = data;
			for(var name in cb){
				var code_func = cb[name];
				if(!codebase[name]){
					codebase[name] = {
						default_version: code_func.version,
						versions:{}
					};
					codebase[name].versions[code_func.version] = {
						body: code_func.body,
						version: code_func.version,
						effective_time: code_func.effective_time, 
						effective_since: code_func.effective_since,
						deprecated: code_func.deprecated
					}
				}
				else{
					var current_version = codebase[name].default_version;
					var fetched_version = code_func.version;
					var compare_result = string_version_compare(current_version, fetched_version);
					if(compare_result === -1){ //fetched version is newer; override the current codebase						
						codebase[name].default_version = fetched_version;
						codebase[name].versions[code_func.version] = {
							body: code_func.body,
							version: code_func.version,
							effective_time: code_func.effective_time, 
							effective_since: code_func.effective_since,
							deprecated: code_func.deprecated
						}
					}
				}
			}
			codebase_initialized = true;
			
		}});
	}; 
	xgov. codebase_get_skeleton = function(param,options){
		if(docs) return {};
		var cb = record_handler.codebase_initialize();
		for(var p in cb){
			if(!codebase[p]){
				codebase[p] = cb[p];
			}
			else{
				
			}
		}	
	};
	xgov. effectuate = function(param,options){
		if(docs) return {};
		if(!record_handler) return options.callback(new Error('Effectuating requires a record handler link to be established first.'));
		if(param.do == "insert") record_handler.insert(param,options);
	};
	xgov. execute = function(obj,options){
		if(docs) return {};
		if(!codebase_initialized) return resolve(false, options, new Error('Codebase not initialized.'));
		try{
			if(!options) options = {};
			if(!options.callback) return false;
			var stxn = obj; //signed txn
			var txnhash = stxn[0], txn = stxn[1], sigs = stxn[2], subm_sigs = stxn[3], meta = stxn[4], follow_ups = stxn[5];
			var is_sysgod = false; for(var i = 0; i < sigs.length; ++i){ if(sigs[i][1] == "SYSGOD") {is_sysgod = true; break;} }
			var valid = xgov.verify(stxn);
			var t = mtime();
			if(valid){
				//xgov.record_keep({record_path:null,signed_txn:stxn});
				//Sysgod primitive executions
				if(!txn.do)
					return resolve(false, options, new Error('Action ("do") not defined'));
				var target_code = codebase[txn.do];
				if(!target_code)
					return resolve(false, options, new Error('Action ("'+txn.do+'") not defined'));
				var path_split = txn.do.split("/");
				var action_full = path_split[path_split.length-1];
				var action = action_full.split(":")[0];
				var action_version = (action_full.indexOf(":") >= 0) ? action_full.split(":")[1] : target_code.default_version;
				var path_depth = path_split.length;
				var codestr = "var exe_func = "+target_code.versions[target_code.default_version].body.toString()+"; exe_func();";
				eval(codestr);
			}
			else{
				return resolve(false, options, new Error("This transaction cannot be validated."));
			}
		}
		catch(e){
			return options.callback(e);
		}
	}; 
	
	xgov. set_domain = function(domain,options){
		xgov_running_domain = domain;
	}
	xgov. start_node = function(param,options){
		if(docs) return {};
	};
	xgov. start_webnode = function(param,options){
		if(docs) return {};
		if(!param) param = {};
		if(!options) options = {};
		var t = mtime();
		var domain = param.domain ? 'https://'+param.domain : 'https://'+xgov_running_domain;
		var webnode_id = webnodes.length;
		var browser_data = window.bros_info_json_b64 ? window.bros_info_json_b64 : "";
		var wn_fid = 0, wn_fobj = {};
		console.log("------------------------------------------------");
		console.log("                                                ");
		console.log("    xGovern Webnode (v"+xgov.get_version()+")      ");
		console.log("                                                ");
		console.log("------------------------------------------------");
		console.log("[Webnode] Fetching webnode worker source script...");
		
		var has_master = false, on_master = [];
		
		var webnode_url = !options.beta ? domain+'/xgov_webnode.js' : domain+'/xgov_webnode_beta.js';
			
		var webnode = new Worker(webnode_url+'?cache_block='+t);
			webnode.aftermaster = function(func,options){
				if(!options) options = {};
				if(has_master){
					func(null,true);
					if(!options.forever) return;
					arr.push({func:func, options:options});
					return;
				}
				if(!options.max_wait) options.max_wait = 30000;
				var arr = on_master;
				var idx = arr.length;
				arr.push({func:func, options:options});
				if(options.max_wait){
					//TODO
				}
			};
			webnode.addEventListener('message', function(e){
				var data = e.data;
				var fid = data.fid;
				var action = data.a;
				if(action){
					if(action == 'prompt_get'){
						prompt.get(data.schema,function(e,result){
							if(e) e = portable_error(e);
							webnode.postMessage({xgov:true, fid:fid, error:e, result:result});
						});
					}
					else if(action == 'server_connection_change'){
						has_master = webnode.master_connected = data.v ? true : false;
						webnode.cid = data.cid;
						if(data.v){
							for(var i = 0; i < on_master.length; ++i){
								var fcb = on_master[i];
								if(fcb && fcb.func){
									fcb.func(null,true); if(!fcb.options.forever) on_master[i] = null;
								}
							}
							on_master = on_master.filter(function(n){return n !== null}); 
						}
						if(ui_handler) ui_handler.handle(action,data.v);
					}
					else if(action == 'webnode_loaded'){
						return resolve({webnode:webnode},options);
					}
				}
				else if(fid){
					var fobj = wn_fobj[fid]; if(fobj){
						if(fobj.callback) fobj.callback(data.error, data.data);
						delete wn_fobj[fid];
					}
				}
				else{
					
				}
			}, false);
			webnode.submit = function(signed_txn,options){
				if(!options) options = {};
				var fid = ++wn_fid; wn_fobj[fid] = {callback:function(e,result){
					if(options.callback) options.callback(e,result);
				}};
				webnode.postMessage({xgov:true, a:'api', func:"submit", arg:signed_txn, fid:fid, options:{async:true}});
			};
			webnode.exec = function(func,param,options){
				var fid = ++wn_fid; wn_fobj[fid] = {callback:function(e,result){
					if(options.callback) options.callback(e,result);
				}};
				var options2 = JSON.parse(JSON.stringify(options));
					options2.async = true;
				webnode.postMessage({xgov:true, a:'api', func:func, arg:param, fid:fid, options:options2});
			}
			webnode.postMessage({xgov:true, a:'set_env', id:webnode_id, bros_info_json_b64:browser_data});
		webnodes.push(webnode);
		return webnode;
	};
	
	xgov. new_thread = function(param,options){
		if(docs) return {};
		if(!param) param = {};
		if(!thread_backlog_being_handled && !is_worker){
			thread_backlog_being_handled = true;
			var backlog_checker_function = function(){
				if(threads.length > 0 && thd_exe_backlog.length > 0){
					var count = 0, max_count = 10000;
					while(thd_exe_backlog.length > 0){
						++count; if(count > max_count) break;
						var exe_data = thd_exe_backlog.shift(); if(!exe_data) continue;
						var result = xgov.thread_execute(exe_data.exeobj,exe_data.options);
						if(result == THREAD_BACKLOG_FLAG) break;
					}
				}
			};
			thread_backlog_checkers.push(setInterval(backlog_checker_function,0));
			thread_backlog_checkers.push(setInterval(backlog_checker_function,0));
			thread_backlog_checkers.push(setInterval(backlog_checker_function,0));
			thread_backlog_checkers.push(setInterval(backlog_checker_function,0));
		}
		try{
			var source;
			var thd_fid = 0, thd_fobj = {}, thd_queue_length = 0;
			if(is_nodeJS_master){
				source = __dirname+"/xgov_beta.js";
			}
			else{
				source = 'https://'+xgov_running_domain+'/xgov_beta.js?'+mtime();
			}
			var thread = new threader(source);
			thread.id = threads.length;
			thread.create_call_pool_idx = param.idx;
			thread.toString = function(){return this.id;}
			thread.get_queue_length = function(){return thd_queue_length;}
			thread.onmessage = function(e){
				if(!e.data || !e.data.xgov) return;
				var data = e.data;
				var fid = data.fid;
				var action = data.a;
				var is_progress = data.progress;
				if(data.xgov_init){
					param.thread = thread;
					return resolve(param,options);
				}
				if(action){
					console.log("Odd worker action: ",e);
				}
				else if(fid){
					var fobj = thd_fobj[fid]; if(fobj){
						if(!is_progress){
							if(fobj.callback) fobj.callback(data.error, data.data);
						}
						else{
							if(fobj.onprogress) fobj.onprogress(data.data);
						}
					}
				}
				else{
					console.log("Odd worker response: ",e);
				}
			};
			thread.execute = function(exeobj,options){
				if(!options) options = {};
				var func = exeobj.func;
				var arg = exeobj.arg;
				var arg_options = exeobj.options;
				var callback = options.callback;
				var onprogress = options.onprogress;
				var fid = ++thd_fid;
				if(thd_queue_length > thread_execute_max_concurrent){
					if(thd_exe_backlog.length > thread_execute_max_backlog){
						var e = new Error('Max execution backlog ');
						if(options.callback) options.callback(e,null);
						return false;
					}
					thd_exe_backlog.push({exeobj:exeobj,options:options});
					return THREAD_BACKLOG_FLAG;
				}
				var callback_called = false;
				var fobj = thd_fobj[fid] = {
					callback:function(e,data){
						if(callback_called) return;
						callback_called = true; delete thd_fobj[fid]; --thd_queue_length;
						if(callback) callback(e,data);
					},
					onprogress:function(data){
						if(onprogress) onprogress(data);
					}
				};
				++thd_queue_length;
				try{
					thread.postMessage({xgov:true, a:'api', func:func, arg:arg, options:arg_options, fid:fid, async:true});
				}
				catch(e){
					callback_called = true; delete thd_fobj[fid]; --thd_queue_length;
					if(callback){
						callback(portable_error(e),null,{fid:fid});
					}
					return;
				}
				var timeout = options.timeout ? options.timeout : thread_execute_default_wait;
				if(options.timeout === 0) timeout = 0;
				if(!isNaN(timeout) && timeout > 0) setTimeout(function(){
					if(callback_called) return;
					callback_called = true; delete thd_fobj[fid]; --thd_queue_length;
					if(callback){
						var e = new Error('Functions timed out func='+func+', arg='+JSON.stringify(arg)+', options='+JSON.stringify(options));
						callback(portable_error(e),null,{fid:fid});
					}
				},timeout);
				return true;
			}
			threads.push(thread);
			return thread;
		}
		catch(e){
			console.log(e);
			console.log("is_worker: "+is_worker);
			console.log(self?self.Worker:Worker);
		}
	};
	xgov. threads_count = function(param,options){
		if(docs) return {};
		if(!options) options = {};
		return resolve(threads.length,options);
	}
	xgov. threads_info = function(param,options){
		if(docs) return {};
		if(!param) param = {};
		if(!options) options = {};
		var best_thread = threads[0];
		var lowest_queue = best_thread ? best_thread.get_queue_length() : 9007199254740991;
		var queue_total = 0;
		for(var i = 0; i < threads.length; ++i){
			var thread = threads[i]; if(!thread) continue;
			var q_len = thread.get_queue_length();
			queue_total += q_len;
			if(q_len <= lowest_queue){
				best_thread = thread;
				lowest_queue = q_len;
			}
		}
		var result = {
			most_free:best_thread,
			total_concurrent:queue_total,
			backlog_count:thd_exe_backlog.length
		};
		if(param.full){
			result.limits = {
				default_timeout:thread_execute_default_wait,
				max_concurrent:thread_execute_max_concurrent,
				max_backlog:thread_execute_max_backlog
			};
		}
		return resolve(result,options);
	};
	xgov. spawn_threads = function(param,options){
		if(docs) return {};
		if(!options) options = {};
		var count = param.count;
		if(param.max){
			if(threads.length >= param.max) return resolve([],options);
			count = Math.floor(param.max - threads.length);
		}
		var pool = [];
		if(!count) count = 1;
		var init_reported = []; init_reported.length = count;
		var all_finished = false, error_triggered = false;
		var reported_successful = [];
		for(var i = 0; i < count; ++i){
			var thd = xgov.new_thread({idx:i},{callback:function(e,data){
				if(error_triggered) return;
				init_reported[data.idx] = true;
				reported_successful.push(data.thread);
				progress_update({idx:data.idx},options);
				all_finished = true;
				for(var a = 0; a < init_reported.length; ++a){if(!init_reported[a]){all_finished=false;break;}}
				if(all_finished){
					return resolve(reported_successful,options);
				}
			}});
			pool.push(thd);
		}
		if(init_reported.length > 0) setTimeout(function(){
			if(all_finished) return;
			error_triggered = true;
			return resolve(reported_successful,options);
		},7000);
		return;
	};
	xgov. thread_execute = function(exeobj,options){
		if(docs) return {};
		if(!options) options = {};
		var best_thread = !options.thread_index ? xgov.threads_info().most_free : threads[options.thread_index];
		if(best_thread){
			var result = best_thread.execute(exeobj,options);
			if(!result){//backlog the execution
				if(thd_exe_backlog.length > thread_execute_max_backlog)
					return resolve(false, options, new Error('Max execution backlog'));
				thd_exe_backlog.push({exeobj:exeobj,options:options});
				return THREAD_BACKLOG_FLAG;
				//console.log("backlogged");
			}
		}
		else{
			return resolve(false, options, new Error('Free thread not found.'));
		}
	};
	
	xgov. get_prompt_executing = function(param,options){
		if(docs) return {};
		return prompt_executing;
	};
	xgov. set_prompt_executing = function(v,options){
		if(docs) return {};
		prompt_executing = v ? true : false;
	};
	
	xgov. get_server_settings = function(param,options){
		if(docs) return {};
		if(is_nodeJS_master){
			var content = fs.readFileSync(xgov_basepath+'servers/default', {encoding:'utf8'});
			if(content) return JSON.parse(content);
			return {};
		}
		else{
			return {};
		}
	}

	xgov. current_secret_loaded = function(param,options){
		if(docs) return {};
		if(!options) options = {};
		if(xgov_current_secret) return resolve(true,options);
		else return resolve(false,options);
	};
	xgov. current_secret_load = function(secret,options){
		if(docs) return {};
		if(!options) options = {};
		xgov_current_secret = secret;
		xgov_current_secret_fetch_time = mtime();
		xgov_current_secret_fetch_exp = options.exp ? options.exp : 0;
		return resolve(true,options);
	};
	xgov. current_secret_unload = function(key,options){
		if(docs) return {};
		if(!options) options = {};
		xgov_current_secret = null;
		xgov_current_secret_fetch_time = 0;
		xgov_current_secret_fetch_exp = 0;
		return resolve(true,options);
	};
	
	xgov. timestamper_loaded = function(param,options){
		if(docs) return {};
		if(!options) options = {};
		if(xgov_timestamper_secret) return resolve(true,options);
		else return resolve(false,options);
	};
	xgov. timestamper_load = function(secret,options){
		if(docs) return {};
		if(!options) options = {};
		xgov_timestamper_secret = secret;
		xgov_timestamper_secret_fetch_time = mtime();
		xgov_timestamper_secret_fetch_exp = options.exp ? options.exp : 0;
		var arr = xgov_timestamper_secret_onloads;
		for(var i = 0; i < arr.length; ++i){
			var a = arr[i];
			if(a && a.func){
				a.func(null,{}); if(!a.options.forever) arr[i] = null;
			}
		}
		arr = arr.filter(function(n){return n !== null}); 
		return resolve(true,options);
	};
	xgov. timestamper_unload = function(key,options){
		if(docs) return {};
		if(!options) options = {};
		xgov_timestamper_secret = null;
		xgov_timestamper_secret_fetch_time = 0;
		xgov_timestamper_secret_fetch_exp = 0;
		return resolve(true,options);
	};
	xgov. timestamper_onload = function(func,options){
		if(docs) return {};
		if(!options) options = {};
		if(!options.max_wait) options.max_wait = 30000;
		var arr = xgov_timestamper_secret_onloads;
		var idx = arr.length;
		arr.push({func:func, options:options});
		if(options.max_wait){
			//TODO
		}
		return idx;
	};
	
	xgov. command_line_interface_start = function(exestr){
		if(docs) return {};
		if(xgov_command_line_interface_checker) return;
		console.log(colors.yellow("------------------------------------------------"));
		console.log(colors.yellow("                                                "));
		console.log(colors.magenta("    xGovern API Console Interface (v"+xgov_interface_version+")      "));
		console.log(colors.yellow("                                                "));
		console.log(colors.yellow("------------------------------------------------"));
		var output_index = 0;
		var output_header = function(){
			return "OUTPUT ("+(output_index++)+"): ";
		}
		var wrap_up_command = function(){
			xgov.set_prompt_executing(false);
			prompt.message = colors.magenta("xgov_command"); 
			prompt.delimiter = "";
		}
		var command_line_func = function(){
			if(xgov_command_line_interface_exit_flag){
				clearInterval(xgov_command_line_interface_checker);
				xgov_command_line_interface_checker = null;
				xgov_command_line_interface_exit_flag = false;
				return;
			}
			if(!xgov.get_prompt_executing()){
				xgov.set_prompt_executing(true);
				var schema = {
					properties:{
						">":{
							required: true,
						},
					}
				};
				prompt.start();
				prompt.message = colors.magenta("xgov_command"); 
				prompt.delimiter = "";
				prompt.get(schema,function(e,result){
					var cmdstr = result[">"];
					try{
					if(cmdstr){
						var cmdlower = cmdstr.toLowerCase();
						if(cmdlower == 'exit'){
							//console.log("xGovern API Console Interface has been terminated by an 'EXIT' signal.");
							console.log("");
							clearInterval(xgov_command_line_interface_checker);
							xgov_command_line_interface_checker = null;
							xgov_command_line_interface_exit_flag = false;
						}
						else if(cmdlower == 'new_address'){
							xgov.generate_address({},{callback:function(e,data){
								try{
								if(e){console.log(colors.red("error"),colors.yellow(": "+e.message)); return wrap_up_command();}
								console.log(output_header()+ JSON.stringify(data));
								wrap_up_command();
								}
								catch(e){console.log(e); wrap_up_command();}
								//xgov. store_secret({name:"timeserver_key",secret:secret},{callback:function(e,data){console.log(data);}});
							}});
						}
						else if(cmdlower == 'new_address_save'){
							xgov.generate_address({},{callback:function(e,data){
								try{
								if(e){console.log(colors.red("error"),colors.yellow(": "+e.message)); return wrap_up_command();}
								console.log(output_header()+ data.address);
								xgov. store_secret({secret:data.secret, prompt:1},{callback:function(e,data){
									try{
									if(e){console.log(colors.red("error"),colors.yellow(": "+e.message)); return wrap_up_command();}
									wrap_up_command();
									}
									catch(e){console.log(e); wrap_up_command();}
								}});
								}
								catch(e){console.log(e); wrap_up_command();}
							}});
						}
						else if(cmdlower == 'new_thread_test'){
							try{
							xgov.new_thread();
							}
							catch(e){console.log(e); wrap_up_command();}
						}
						else if(cmdlower == 'load_secret'){
							xgov. retrieve_secret({prompt:1},{callback:function(e,data){
								try{
								if(e){console.log(colors.red("error"),colors.yellow(": "+e.message)); return wrap_up_command();}
								xgov.load_secret(data);
								wrap_up_command();
								}
								catch(e){console.log(e); wrap_up_command();}
							}});
						}
						else if(cmdlower == 'unload_secret'){
							if(!xgov.secret_loaded()){
								console.log(colors.red("error"),colors.yellow(": no current secret loaded"));
								wrap_up_command();
							}
							xgov.unload_secret();
							console.log("Loaded secret has been unloaded");
						}
						else if(cmdlower == 'help'){
							
						}
						else{
							console.log(output_header()+" Unknown command: "+cmdstr);
							wrap_up_command();
						}
					}
					}
					catch(e){console.log(e); wrap_up_command();}
				});
			}
		};
		command_line_func();
		xgov_command_line_interface_checker = setInterval(command_line_func,333);
		return true;
	}
	
	xgov. omnizen_get_new_id = function(address,options){
		if(docs) return {};
		return xgov.random_hash_b30(12);
	}
	xgov. omnizen_register = function(initial_data,options){
		if(docs) return {};
		xgov.generate_address({},{callback:function(e,data){
			var omnizen_id = xgov.omnizen_get_new_id();
			var omnizen_new_account_obj = xgov.sanitize_empty_string({
				do:"omnizen/account/create",
				id:omnizen_id,
				public_key:data.address,
				is_beta_account:true,
				name_first:"",
				name_last:"",
				sdfsdfds:{sdfdf:""},
				name_middles:[],
			});
			try{
				var signed = xgov.sign(omnizen_new_account_obj,{verbose:1,secret:data.secret/*also_sign_submission_time:true*/});
			}
			catch(e){console.log(e);}
			if(xgov.verify(signed,{verbose:1})){
				console.log("verified");
				webnode.submit(signed,{async:1},function(e,data){
					if(e) return resolve(false,e,data);
					//resolve(data,
				});	
			}
			else{
				console.log("Unverifiable");
			}
		}});
	}
	
	xgov. get_version = function(param,options){
		if(docs) return {};
		return xgov_interface_version;
	};
	
	//RKM key recovery protocol; for more information and API visit https://github.com/xgovern/rkm
	xgov. rkm_digest = function(param,options){
		if(!param) param = {};
		if(!options) options = {};
		
		//Initial parameter cleaning
		var rkm_version = '0.6.12';
		var start_t = mtime();
		var encryption_password = param.password+"";
		var private_key = param.private_key; //TODO Private key rubric detection
		var private_key_decoded;
		var format_name;
		var private_key_format = 'xgov';
		if(private_key.length == 43 || private_key.length == 44){//Base62
			private_key_decoded = xgov.base62_decode(private_key);
			private_key_format = 'xgov';
		}
		else if(private_key.length == 64){//Hex; e.g. ETH
			try{
				private_key_decoded = xgov.hex_decode(private_key);
				private_key_format = 'ether';
			}
			catch(e){console.log(e);}
		}
		else if(private_key.length < 43){//Base60 or lower; try multiple
			var try_pool = ['bitcoin','ripple','stellar'];
			for(var i = 0; i < try_pool.length; ++i){
				try{
					private_key_decoded = xgov.address_codec_decode({name:format_name,encoded:private_key});
				}
				catch(e){private_key_decoded=null;}
				if(private_key_decoded){
					private_key_format = format_name;
					break;
				}
			}
		}
		if(!private_key_decoded) return resolve(false,options,new Error('Failed to decode the private key, please check to see your token private key format is supported.'));
		private_key = xgov.base62_encode(private_key_decoded);
		
		if(param.key_check_only) return resolve(true,options);
		
		//Questions and answers
		var questions = param.questions;
		var answers = param.answers;
		if(questions.length != answers.length) resolve(false,options,new Error('Number of questions and answers does not match.'));
		if(questions.length < 0) resolve(false,options,new Error('At least one question & answer set is required'));
		var all_answers_concat = answers.join("|");
		
		//False Positive Rate Clean
		var false_positive_rate = param.false_positive_rate;
		if(isNaN(false_positive_rate) || false_positive_rate < 2) false_positive_rate = "33%";
		var given_fp = parseFloat(false_positive_rate) / 100.0;
		var false_positive_collision_rate = given_fp; if(false_positive_collision_rate < 1/256) false_positive_collision_rate = 1/256;
		if(false_positive_collision_rate >= 1) false_positive_collision_rate = 1;
		var false_positives = Math.round(1/false_positive_collision_rate);
		//console.log("false positive",false_positives);
		
		//NOQ wrapping set-up	
		var noq = questions.length; //Number of Questions
		
		//default mapping byte calculations
		var map_byte = param.map_byte;
		if(noq <= 10) map_byte = 3; else map_byte = 2;
		if(!isNaN(param.map_byte) && param.map_byte > map_byte){
			if(param.map_byte > 8) resolve(false,options,new Error('Maximum mapping byte is 8 bytes and each additional byte will cause x256 execution delay (2-byte mapping byte takes about 1~10 seconds each question.)'));
			map_byte = Math.floor(param.map_byte);
		}
		
		var clean_number = function(v,df,unsigned){//value, default value, must be unsigned
			if(df === undefined || df === null) df = 0;
			df = parseFloat(df); if(isNaN(df)) df = 0;
			v = parseFloat(v);
			if(isNaN(v)) return unsigned ? Math.abs(df) : df;
			return unsigned ? Math.abs(v) : v;
		}
		var minimum_iteration_password = clean_number(param.minimum_iteration_password, 1,true) * 1000000;
		var minimum_iteration_answer = clean_number(param.minimum_iteration_answer, 1,true) * 1000000;
		var minimum_iteration_mask = clean_number(param.minimum_iteration_mask, 1,true) * 1000000;
		
		//Multicore Helping Threads
		var thread_count = param.thread_count;
		if(isNaN(thread_count) || thread_count < 16) thread_count = 16;
		
		//Report Batch Size
		var batch_size = param.batch_size ? param.batch_size : 17821;
		if(isNaN(batch_size) || batch_size < 1000) batch_size = 1000;
		
		//Private Key Masking
		var rounds = Math.floor(32/map_byte);
		var remainder = 32 % map_byte; if(remainder !== 0) ++rounds;
		
		//Wrapped QnA
		var questionnaire = []; questionnaire.length = rounds;
		var salts = []; salts.length = rounds;
		var finished = []; finished.length = rounds;
		
		//Answer Filter Type
		var answer_filter = function(str){//Default answer string filtration function
			str = str.toLowerCase();
			str = str.replace(/[`~!@#$%^&*()_|+\-=?;:'",.<>\{\}\[\]\\\/]/gi, '');
			str = str.replace(/\s/g,'');
			return str;
		};
		var answer_filter_type = param.answer_filter; //If other, filter use different filtering rubric
		if(!answer_filter_type) answer_filter_type = false;
		
		//Static salt for the entire questionnaire and iteration matching
		var salt_length = param.salt_length;
		if(isNaN(salt_length) || salt_length < 16) salt_length = 16;
		var salt = xgov.random_hash_raw(salt_length);
		
		//Do check the result
		var do_check_digestion = false;
		
		xgov.spawn_threads({max:thread_count},{
		callback:function(e,data){
			if(e) return resolve(false,options,new Error("Could not initialize a single thread."));
			progress_update({type:"thread_spawn_complete"},options);
			xgov.thread_execute({
					func:"sha512_iterate", 
					arg:{
						encoding:'base62',
						hash:xgov.sha512(encryption_password,{raw_output:true}),
						type:'iterate',
						count:minimum_iteration_password,
						batch_size:batch_size
					}
				},
				{timeout:0, //IMPT!! with large iteration
				callback:function(e,data){
					if(e) return resolve(false,options,new Error("Failed to iterate hash"));
					progress_update({type:"password_iteration_complete"},options);
					var password_hash = data.hash;
					//Mask the private key PWXOR
					var pwxor = xgov.pwxor({data:private_key, password:password_hash});
					var key = xgov.base62_decode(pwxor);
					xgov.thread_execute({
							func:"sha512_iterate", 
							arg:{
								encoding:'base62',
								hash:xgov.base62_encode(xgov.sha512(all_answers_concat,{raw_output:true})),
								type:'iterate',
								count:minimum_iteration_mask,
								batch_size:batch_size,
							}
						},
						{timeout:0, //IMPT!! no timeout with large iteration
						callback:function(e,data){
							if(e) return resolve(false,options,new Error("Failed to iterate mask"));
							progress_update({type:"mask_iteration_complete"},options);
							
							//Mask the private key PWXOR
							var mask = xgov.base62_decode(data.hash);
							for(var i = 0; i < key.length; ++i) key[i] = key[i] ^ mask[i]; //XOR mask generated from all_answers_concat hash
							
							var byte_at = 0;
							var count = 0;
							var found = false;
							var next = false;
							for(var i = 0; i < rounds; ++i){
								var idx = i, a = idx % noq, last_bit = (remainder > 0 && i+1 === rounds);
								var ans = answer_filter(answers[a]), que = questions[a];
								var ans_buffer = xgov.buffer_encode(ans);
								var prehash = new Uint8Array(salt_length + ans_buffer.length);
								for(var j = 0; j < salt_length; ++j) prehash[j] = salt[j];
								for(var j = salt_length; j < prehash.length; ++j) prehash[j] = ans_buffer[j+salt_length];
								var mapping_length = last_bit ? remainder : map_byte;
								var match_byte = (mapping_length===1||mapping_length===2) ? key[byte_at]:
													((mapping_length===3) ? [key[byte_at],key[byte_at+1]]
														: [key[byte_at],key[byte_at+1],key[byte_at+2]]);
								var check_byte = key[byte_at+(mapping_length-1)];
								xgov.thread_execute({
										func:"sha512_iterate", 
										arg:{
											index: idx,
											pair: {question:que,answer:ans},
											encoding: 'base62',
											hash: xgov.base62_encode(prehash),
											type: 'RKM_search',
											minimum: minimum_iteration_answer,
											map_byte: mapping_length,
											match_byte: match_byte,
											check_byte: check_byte,
											batch_size: batch_size,
										}
									},
									{timeout:0, //IMPT!! with large iteration
									callback:function(e,data){
										if(e) return resolve(false,options,new Error("Failed to iterate hash for an answer."));
										var idx = data.arg.index;
										data.type = "answer_iteration_partial_complete";
										progress_update(data,options);
										questionnaire[idx] = [
											null, 										//optional question specific salt
											data.iteration, 							//required iteration
											data.arg.map_byte, 							//mapping byte length
											data.arg.check_byte % false_positives, 		//check byte value for false positive
											data.arg.pair.question 						//question
										];
										finished[idx] = true;
										var all_finished = true;
										for(var i = 0; i < finished.length; ++i){if(!finished[i]){all_finished=false;break;}}
										if(all_finished){
											var end_t = mtime();
											var time_taken_in_seconds = ((end_t - start_t) / 1000);
											progress_update({type:"answer_iteration_all_complete", duration:time_taken_in_seconds},options);
											//Final questionnaire format
											var questionnaire_obj = {
												key_format:private_key_format,
												mask_iteration:minimum_iteration_mask,
												false_positive_mod:false_positives,
												salt:xgov.base62_encode(salt),
												salt_length:salt_length,
												list:questionnaire
											};
											if(answer_filter_type) questionnaire_obj.answer_filter_type = answer_filter_type;
											var questionnaire_json_gzip = gzip_compress(JSON.stringify(questionnaire_obj),'Uint8Array');
											var pw_digest = xgov. password_digest(password_hash);
											var encrypted_questionnaire = xgov.secretbox({
												buffer:questionnaire_json_gzip, 
												nonce:pw_digest.nonce,
												secret:pw_digest.secret
											});
											var encrypted_questionnaire_b62 = xgov.base62_encode(encrypted_questionnaire);
												encrypted_questionnaire_b62 = "RKMv"+rkm_version
																			+"_"+minimum_iteration_password
																			+"_"+encrypted_questionnaire_b62;
											return resolve(encrypted_questionnaire_b62, options);
										}
									},
									onprogress:function(data){
										//console.log(data);
										data.type = "answer_iteration";
										progress_update(data,options);
									}
								});
								byte_at += map_byte;
							}
						},
						onprogress:function(data){
							data.type = "mask_iteration";
							progress_update(data,options);
						}
					});
				},
				onprogress:function(data){
					data.type = "password_iteration";
					progress_update(data,options);
				}
			});
		},
		onprogress:function(e,data){
			data.type = "thread_spawn";
			progress_update(data,options);
		}});
	};
	xgov. rkm_recover = function(param,options){
		if(!param) param = {};
		if(!options) options = {};
		
		var questionnaire_string = param.questionnaire_string;
		var encryption_password = param.password+"";
		var answers = param.answers; 
		var batch_size = param.batch_size ? param.batch_size : 17821;
		if(isNaN(batch_size) || batch_size < 1000) batch_size = 1000;
		
		var questionnaire_split = questionnaire_string.split("_");
		var version_info = questionnaire_split[0];
		var pw_iteration = parseInt(questionnaire_split[1]);
		var encrypted_questionnaire_b62 = questionnaire_split[2];
		
		xgov.spawn_threads({max:thread_count},{
		callback:function(e,data){
			if(e) return resolve(false,options,new Error("Could not initialize a single thread."));
			progress_update({type:"thread_spawn_complete"},options);
			xgov.thread_execute({
				func:"sha512_iterate", 
				arg:{
					encoding:'base62',
					hash:xgov.sha512(encryption_password,{raw_output:true}),
					type:'iterate',
					count:pw_iteration,
					batch_size:batch_size
				}
			},
			{timeout:0, //IMPT!! with large iteration
			callback:function(e,data){
				if(e) return resolve(false,options,new Error("Failed to iterate hash for an encryption password."));
				progress_update({type:"password_iteration_complete"},options);
				try{
					var pw_digest = xgov. password_digest(data.hash);
					var encrypted_questionnaire_buffer = xgov.base62_decode(encrypted_questionnaire_b62);
					var opened_questionnaire_gzip = xgov.secretbox_open({
						buffer:encrypted_questionnaire_buffer,
						nonce:pw_digest.nonce,
						secret:pw_digest.secret
					});
					var opened_questionnaire_json = gzip_decompress(opened_questionnaire_gzip);
					var opened_questionnaire = JSON.parse(opened_questionnaire_json);
					var opened_questionnaire_list = opened_questionnaire.list;
				
					var rec_pos = 0;
					var rec_salt = xgov.base62_decode(opened_questionnaire.salt);
					var false_positives = opened_questionnaire.false_positive_mod;
					var minimum_mask_iteration = opened_questionnaire.mask_iteration;
					var noq = opened_questionnaire_list.length;
				
					var answer_filter = function(str){//Default answer string filtration function
						str = str.toLowerCase();
						str = str.replace(/[`~!@#$%^&*()_|+\-=?;:'",.<>\{\}\[\]\\\/]/gi, '');
						str = str.replace(/\s/g,'');
						return str;
					};
					var answer_filter_type = param.answer_filter;
					if(answer_filter_type){
						//If other, filter use different filtering rubric
					}
				
					var all_answers = []; for(var i = 0; i < noq; ++i) all_answers.push(answers[i]); all_answers = all_answers.join("|");
					xgov.thread_execute({
						func:"sha512_iterate", 
						arg:{
							encoding:'base62',
							hash:xgov.base62_encode(xgov.sha512(all_answers,{raw_output:true})),
							type:'iterate',
							count:minimum_mask_iteration,
							batch_size:42821,
						}
					},
					{timeout:0, //IMPT!! with large iteration
						callback:function(e,data){
							if(e) return resolve(false,options,new Error("Cannot iterate through mask layer the hash "+e.message));
							progress_update({type:"mask_iteration_complete"},options);
							var mask = xgov.base62_decode(data.hash);
							var iterations = [];
							var map_bytes = [];
							var check_bytes = [];
							var questions = [];
							for(var i = 0; i < opened_questionnaire_list.length; ++i){
								var iteration = iterations[idx] = opened_questionnaire_list[i][1];
								var map_byte = map_bytes[idx] = opened_questionnaire_list[i][2];
								var check_byte = check_bytes[idx] = opened_questionnaire_list[i][3];
								var question = questions[idx] = opened_questionnaire_list[i][4];
								
								//Todo
								
							}
						},
						onprogress:function(data){
							data.type = "mask_iteration";
							progress_update(data,options);
						}
					});
				}
				catch(e){
					return resolve(false,options,new Error("Could not decrypt the encrypted questionnaire: "+e.message));
				}
			},
			onprogress:function(data){
				data.type = "password_iteration";
				progress_update(data,options);
			}
		});
		},
		onprogress:function(e,data){
			data.type = "thread_spawn";
			progress_update(data,options);
		}});
		
		recover_next = function(){
		if(recovery_step === 1){
				mask_completed = false;
				var all_answers_concat = [];
				for(var i = 1; i <= noq; ++i) all_answers_concat.push(answer_filter(docget("sqkr_a"+i).getAttribute("df_val")));
				all_answers_concat = all_answers_concat.join("|");
				console.log(all_answers_concat);
				console.log(xgov.buffer_encode(all_answers_concat));
				xgov.thread_execute({
					func:"sha512_iterate", 
					arg:{
						encoding:'base62',
						hash:xgov.base62_encode(xgov.sha512(xgov.buffer_encode(all_answers_concat),{raw_input:true,raw_output:true})),
						type:'iterate',
						count:minimum_mask_iteration,
						batch_size:42821,
					}
				},
				{timeout:0, //IMPT!! with large iteration
				callback:function(e,data){
					if(e) return console.log(e);
					mask = xgov.base62_decode(data.hash);
					console.log("MASK = "+data.hash);
					mask_completed = true;
				}});
			}
			docget("sqkr_a"+recovery_step).value = docget("sqkr_a"+recovery_step).getAttribute("df_val");
			docget("sqkr_a"+recovery_step).scrollIntoView({behavior:"smooth",block:"center"});
			setTimeout(function(){docget("sqkr_a"+recovery_step).focus();},30);
			var check_byte = check_bytes[recovery_step];
			var iteration = iterations[recovery_step];
			var salt = rec_salt;
			docget("sqkr_q"+recovery_step).value = questions[recovery_step];
			docget("sqkr_a"+recovery_step).onkeydown = function(e){
				if(checking_inprogress || parseInt(this.id.split("sqkr_a")[1]) != recovery_step) return;
				var k = event.which || event.keyCode;
				if(k == 13){//Enter
					checking_inprogress = true;
					var ans = answer_filter(docget("sqkr_a"+recovery_step).value);
					var ans_buffer = xgov.buffer_encode(ans);
					var prehash = new Uint8Array(salt_length+ans_buffer.length);
					var map_byte = map_bytes[recovery_step];
						//console.log(map_bytes); console.log(map_byte);	
					for(var j = 0; j < salt_length; ++j) prehash[j] = salt[j];
					for(var j = salt_length; j < prehash.length; ++j) prehash[j] = ans_buffer[j+salt_length];
					xgov.thread_execute({
							func:"sha512_iterate", 
							arg:{
								index:recovery_step,
								encoding:'base62',
								hash:xgov.base62_encode(prehash),
								type:'iterate',
								count:iteration,
								batch_size:42821,
								map_byte:map_byte,
							}
						},
						{timeout:0, //IMPT!! with large iteration
						callback:function(e,data){
							if(e) return console.log(e);
							var idx = data.arg.index;
							docget("sqkr_tc"+idx).innerHTML = "(100%)";
							checking_inprogress = false;
							var hash = xgov.base62_decode(data.hash);
							if(false_positives === 1 || (hash[data.arg.map_byte-1] % false_positives === check_byte % false_positives)){ //Matches next question
								for(var i = 0; i < data.arg.map_byte; ++i)
									rec_bytes[rec_pos+i] = hash[i];
								rec_pos += data.arg.map_byte;
								docget("sqkr_img"+idx).src = "https://xgov.s3-accelerate.amazonaws.com/check.png";
								docget("sqkr_q"+idx).value = "";
								docget("sqkr_a"+idx).value = "";
								++recovery_step;
								if(recovery_step > opened_questionnaire_list.length){
									if(!mask_completed) console.log(new Error("!!!!! MASK NOT COMPLETED !!!!!"));
									for(var i = 0; i < rec_bytes.length; ++i) rec_bytes[i] = rec_bytes[i] ^ mask[i]; //XOR mask generated from all 16 answers
									var pwxor = xgov.base62_encode(rec_bytes);
									docget("sqkr_rkey").value = pwxor;
									var recontituted_pkey = xgov.pwxor({data:pwxor, password:pwxor_password});
									docget("sqkr_rkey1").value = recontituted_pkey;
									setTimeout(function(){
										docget("sqkr_rkey1").scrollIntoView({behavior:"smooth",block:"center"});
									},500);
									if(docget("sqkr_pkey").value.length > 0){
										if(docget("sqkr_rkey1").value == docget("sqkr_pkey").value){
											docget("sqkr_rkey1").classList.add("potion_border");
											docget("sqkr_rkey1_msg").style.color = "purple";
											docget("sqkr_rkey1_msg").innerHTML = "Private key matches the original!";
										}
										else{
											docget("sqkr_rkey1").style.border = "1px solid red";
											docget("sqkr_rkey1_msg").style.color = "red";
											docget("sqkr_rkey1_msg").innerHTML = "Private key does not match";
										}
									}
									else{
									
									}
									recovery_step = 1;
									quetionnaire_unlocked = false;
									docget("sqkr_recovery_start").classList.remove("button_disabled");
									docget("sqkr_recovery_input").disabled = false;
								}
								else{
									recover_next();
								}
							}
							else{
								docget("sqkr_img"+recovery_step).src = "https://xgov.s3-accelerate.amazonaws.com/ex_ico_small.png";
							}
						},
						onprogress:function(data){
							var idx = data.arg.index;
							docget("sqkr_tc"+idx).innerHTML = "("+(data.count/iteration*100).toFixed(2)+"%)";
						}
					});
				}
			}
		}
		docget("sqkr_recovery_start").onclick = function(){
			if(!quetionnaire_unlocked){
				docget("sqkr_digest_start").classList.add("button_disabled");
				var encrypted_questionnaire_b62 = docget("sqkr_recovery_input").value;
				xgov.prompt({
					message:"Enter password to pwxor-decrypt the encrypted questionnaire:",
					affirmative_ico:'https://s3.amazonaws.com/jvs-static/img/real_lock_ico2.png',
					affirmative:'DECRYPT',
					properties:{
						password:{
							required:true, hidden:true, label:"PWXOR Password"
						}
					}
				},
				{callback:function(e,data){
					if(e) return console.log(e);
					if(!data) return console.log("Canceled");
					encrypted_questionnaire_b62 = encrypted_questionnaire_b62.split("_");
					var version_info = encrypted_questionnaire_b62[0];
					var pw_iteration = parseInt(encrypted_questionnaire_b62[1]);
					encrypted_questionnaire_b62 = encrypted_questionnaire_b62[2];
					console.log(version_info);
					console.log(pw_iteration);
					xgov.thread_execute({
							func:"sha512_iterate", 
							arg:{
								index:recovery_step,
								encoding:'base62',
								hash:xgov.sha512(data.password,{raw_output:true}),
								type:'iterate',
								count:pw_iteration,
								batch_size:42821
							}
						},
						{timeout:0, //IMPT!! with large iteration
						callback:function(e,data2){
							if(e) return console.log(e);
							docget("rec_pwxor_hash_iter").innerHTML = "(100%)";
							pwxor_password = data2.hash;
							console.log("PWXOR_PW = "+data2.hash);
							try{
								var pw_digest = xgov. password_digest(pwxor_password);
								var encrypted_questionnaire_buffer = xgov.base62_decode(encrypted_questionnaire_b62);
								var opened_questionnaire_gzip = xgov.secretbox_open({buffer:encrypted_questionnaire_buffer, nonce:pw_digest.nonce, secret:pw_digest.secret});
								var opened_questionnaire_json = gzip_decompress(opened_questionnaire_gzip);
								var opened_questionnaire = JSON.parse(opened_questionnaire_json);
								//console.log(opened_questionnaire);
								opened_questionnaire_list = opened_questionnaire.list;
								rec_pos = 0;
								rec_salt = xgov.base62_decode(opened_questionnaire.salt);
								false_positives = opened_questionnaire.false_positive_mod;
								minimum_mask_iteration = opened_questionnaire.mask_iteration;
								noq = opened_questionnaire_list.length;
								for(var i = 0; i < opened_questionnaire_list.length; ++i){
									var idx = i+1;
									iterations[idx] = opened_questionnaire_list[i][1];
									map_bytes[idx] = opened_questionnaire_list[i][2];
									check_bytes[idx] = opened_questionnaire_list[i][3];
									questions[idx] = opened_questionnaire_list[i][4];
								}
								//console.log(opened_questionnaire_list);
								quetionnaire_unlocked = true;
								recover_next();
								docget("sqkr_recovery_start").classList.add("button_disabled");
								docget("sqkr_recovery_input").disabled = true;
								for(var i = 1; i <= 16; ++i){
									if(docget("sqkr_tc"+i)) docget("sqkr_tc"+i).innerHTML = "(Hit 'Enter' to check answer)";
								}
							}
							catch(e){
								notify("Could not decrypt the encrypted questionnaire.");
								console.log(e);
							}
						},
						onprogress:function(data){
							var idx = data.arg.index;
							docget("rec_pwxor_hash_iter").innerHTML = "("+(data.count/mininum_pw_iteration*100).toFixed(2)+"%)";
						}
					});
				}});
				return;
			}
		}	
	};
	
	xgov. _test = function(param,options){
		if(docs) return {};
	};
	
	//Documentation import
	if(docs){
		var docs_object = {};
		for(var fname in xgov){
			try{
				if(is_function(xgov[fname])){
					docs_object[fname] = xgov[fname]();
				}
			}
			catch(e){
				//console.log(e);
			}
		}
		console.log("xGovern Documentation Imported.");
		docs = false;
	}
	
	
	//Default codebase
	codebase["xgov/codebase/create"] = {
		default_version:"1.0",
		versions:{
			"1.0":{
				effective_time:0, effective_since:0, deprecated:0,
				body:function(){
					if(!is_sysgod) return options.callback(null,{result:"FAILURE", error:new Error('Code modification can only be done by SYSGOD'), ts:t});
					var default_func_data = { 
						id:txn.id, t:0, created:txn.t, updated:txn.t, create_txn:txnhash,
						name:"defaults/"+txn.name, func:{
							version:"1.0",
							deprecated:0,
							effective_time:txn.effective_time,
							effective_since:txn.effective_since,
							body:txn.body
						},
						lock_t:0, locker:null,
						ledger:[txnhash]
					};
					var func_version_data = JSON.parse(JSON.stringify(default_func_data));
						func_version_data.name = txn.name+":1.0";
					xgov.effectuate({
						do:"insert",
						ledger:"xgov/codebase/ledger", until:time()+7*day,
						info:txn.desc ? txn.desc : "Codebase create: "+txn.name,
						stxn:stxn,
						logic:[
							{	
								do:"insert", on:"xgov/codebase", unique:{key:["name","t"]},
								data:default_func_data
							},
							{	
								do:"insert", on:"xgov/codebase", unique:{key:["name","t"]},
								data:func_version_data
							},
						]
					},{callback:function(e,data){
						if(options.callback) options.callback(e,data);
					}});
				}
			}
		}
	};
	codebase["xgov/codebase/update"] = {
		default_version:"1.0",
		versions:{
			"1.0":{
				effective_time:0, effective_since:0, deprecated:0,
				body:function(){
					if(!is_sysgod) return options.callback(null,{result:"FAILURE", error:new Error('Code modification can only be done by SYSGOD'), ts:t});
					//local server update
					var default_func_data = { 
						id:txn.id, t:0, created:txn.t, updated:txn.t, create_txn:txnhash,
						name:"defaults/"+txn.name, func:{
							version:"1.0",
							deprecated:0,
							effective_time:txn.effective_time,
							effective_since:txn.effective_since,
							body:txn.body
						},
						lock_t:0, locker:null,
						ledger:[txnhash]
					};
					xgov.effectuate({
						do:"insert",
						ledger:"xgov/codebase/ledger", until:time()+7*day,
						info:txn.desc ? txn.desc : "Codebase update to "+txn.name,
						stxn:stxn,
						logic:[
							{	
								do:"update", on:"xgov/codebase", unique:{key:["id","t"]},
								data:new_data
							},
						]
					},{callback:function(e,data){
						if(options.callback) options.callback(e,data);
					}});
				}
			}
		}
	};
	codebase["xgov/group/country/create"] = {
		default_version:"1.0",
		versions:{
			"1.0":{
				effective_time:0, effective_since:0, deprecated:0,
				body:function(){
					if(!is_sysgod) return options.callback(null,{result:"FAILURE", error:new Error('Country creation can only be done by SYSGOD'), ts:t});
					var new_data = { 
						id:txn.id, t:0, created:txn.t, updated:txn.t, create_txn:txnhash,
						name:txn.name, class:txn.class,
						info:{code:txn.code},
						auto_approve_membership: txn.auto_approve_membership ? true : false,
						_testnet: txn._testnet ? true : false,
						lock_t:0, locker:null,
						ledger:[txnhash]
					};
					//if(is_sysgod) new_data.approved = true; else new_data.approved = false;
					xgov.effectuate({
						do:"insert",
						ledger:"xgov/group/ledger", until:time()+7*day,
						info:"New group: xgov/group with id: "+txn.id,
						stxn:stxn,
						logic:[
							{	
								do:"new", on:"xgov/group", unique:{key:["id","t"]},
								data:new_data
							},
						]
					},{callback:function(e,data){
						if(options.callback) options.callback(e,data);
					}});
				}
			}
		}
	};
	
	//Default codebase for Omnizen
	codebase["omnizen/person/create"] = {
		default_version:"1.0",
		versions:{
			"1.0":{
				effective_time:0, effective_since:0, deprecated:0,
				body:function(){
					var new_data = { 
						id:txn.id, t:0, created:txn.t, updated:txn.t, create_txn:txnhash,
						type:txn.type,
						public_key:txn.public_key,
						key_history:[{key:txn.public_key, from:txn.t, evt:"new"}],
						key_suspended:"no",
						auth:{
							sha:{
								keys:[],
								phones:[],
								emails:[]
							},
							ringkeys:[],
							bioembeds:[],
							biometrics:[],
							source:{
								trusted:{
									devices:[],
									ips:[],
								},
								blacklist:{
									country:[],
									rubrics:[]
								},
							},
							recovery:{
								vouchers:[]
							},
							guardians:[],
						},
						public:{
							info:{
								name:{
									screen:txn.name_screen,
									full:txn.name_full,
									first:txn.name_first,
									last:txn.name_last,
									middles:txn.name_middles,
								},
								intl:{
							
								},
							},
							meta:{},
						},
						settings:{
							credential_rubric:"null",
							rubric_exceptions:[]
						},
						nodes:[],
						_testnet: txn._testnet ? true : false,
						lock_t:0, locker:null,
						ledger:[txnhash] 
					};
					xgov.effectuate({
						do:"insert",
						ledger:"omnizen/person/ledger", until:time()+7*day,
						info:"New account: omnizen/person with id: "+txn.id,
						stxn:stxn,
						logic:[
							{	
								do:"insert", on:"omnizen/person", unique:{key:["id","t"]},
								data:new_data
							},
						]
					},{callback:function(e,data){
						if(options.callback) options.callback(e,data);
					}});
				}
			}
		}
	};
	codebase["omnizen/account/create"] = {
		default_version:"1.0",
		versions:{
			"1.0":{
				effective_time:0, effective_since:0, deprecated:0,
				body:function(){
					var new_data = { 
						id:txn.id, t:0, created:txn.t, updated:txn.t, create_txn:txnhash,
						owner_id:txn.owner_id,
						jurisdiction: is_object(txn.jurisdiction) ? jurisdiction : {}
					};
					if(is_sysgod) new_data.approved = true; else new_data.approved = false;
					xgov.effectuate({
						do:"insert",
						ledger:"omnizen/account/ledger",
						stxn:stxn,
						info:"New account: omnizen/account with id: "+txn.id,
						effects:[
							{do:"insert", on:"omnizen/account", unique:{key:["id"]},
								data:new_data
							},
						]
					},{callback:function(e,data){
						if(options.callback) options.callback(e,data);
					}});
				}
			}
		}
	};
	
	
	try{if(is_nodeJS_master && module) module.exports = xgov;}
	catch(e){}
	
	Object.freeze(xgov);
    return xgov;
})();

//Woker COM
var _worker_id = null;
this.onmessage = function(e){
	if(!e.data || !e.data.xgov) return;
	var dat = e.data;
	var fid = dat.fid;
	var action = dat.a;
	var is_progress = dat.progress ? true : false;
	if(action){
		if(action == 'api'){
			if(xgov[dat.func] !== undefined){
				var options = dat.options ? dat.options : {};
				if(!options.sync){
					if(!options.callback)
						options.callback = function(e,data){
							if(e) e = portable_error(e);
							postMessage({xgov:true, fid:fid, data:data, error:e});
						};
					if(!options.onprogress)
						options.onprogress = function(data){
							postMessage({xgov:true, fid:fid, data:data, progress:true});
						};
				}
				var has_error = false;
				if(!options.sync){
					try{var ret = xgov[dat.func](dat.arg,options);}
					catch(e){postMessage({xgov:true, fid:dat.fid, data:null, error:portable_error(e)});}
				}
				else{
					var ret;
					try{ret = xgov[dat.func](dat.arg,options);}
					catch(e){console.log(e); has_error = true; postMessage({xgov:true, fid:dat.fid, data:null, error:portable_error(e)});}
					if(!has_error) postMessage({xgov:true, fid:dat.fid, data:ret});
				}
			}
			else{
				postMessage({xgov:true, fid:dat.fid, data:null, error:portable_error('Unknown API function '+dat.func)});
			}
		}
		else if(action == 'set_env'){
			_worker_id = dat.id; console.log('Worker ID set: '+_worker_id);
			postMessage({xgov:true, fid:dat.fid, data:true});
		}
		else if(action == 'terminate'){
			console.log('[Worker '+_worker_id+'] terminated.');
			self.close();
		}
	}
	else{
		if(!fobjs) return;
		var fobj = fobjs[fid]; if(fobj){
			if(!is_progress){
				if(fobj.cb) fobj.cb(dat.error, dat.result);
				else if(fobj.callback) fobj.callback(dat.error, dat.result);
				delete fobj[fid];
			}
			else{
				if(fobj.onprogress) fobj.onprogress(dat);
			}
		}
	}
}
try{this.postMessage({xgov:true, xgov_init:true});}catch(e){}

if(is_nodeJS_master){
	var env_specifier;
	var LOCAL_TEST_ENV = false;
	try{
		env_specifier = fs.readFileSync('/var/www/nodejs/nodejs_running_env', 'utf8').trim();
		LOCAL_TEST_ENV = (env_specifier == 'LOCAL_TEST_ENV'); //vs. SERVER_PRODUCTION_ENV
	}
	catch(e){LOCAL_TEST_ENV = true;}

	if(LOCAL_TEST_ENV){
		
		
	}
}
else if(beta_mode){
	
}









