/*
//=============================================================================================================
//
//		Name        : 	xGovern Webnode
//		Author      : 	Joe K. Kim (J.K.K.)
//		Site		:	xgovern.com
//		Version     : 	1.5.11
//		
//		!!! Proprietary !!!
//
//		© 2018 xGovern Inc., all rights reserved.
//		Unauthorized copying of this file, via any medium is strictly prohibited.
//		Written by Joe K. Kim <jkk@xgovern.com>
//
//=============================================================================================================
*/

var is_xgov_webnode = true;
var is_nodeJS = new Function("try {return this===global;}catch(e){return false;}"); is_nodeJS = is_nodeJS();
var clog = console.log; if(xgov_console_override) console.log = function(){
	var e = new Error;
	if(e.stack){
		var split = e.stack.split("\n");
		var split2 = split[2].split('https://xgovern.com/')[1];
		var split3 = split2.split('?');
		var file = split3[0];
		var info_split = split3[1].split(':'); info_split.shift();
		var path = file+":"+info_split[0];
		var str = (typeof arguments[0] == 'object') ? JSON.stringify(arguments[0]) : arguments[0];
		clog('[xGovern WebNode; inst_'+webnode_id+'] : '+str+" (at "+path+")");
	}
	else{
		var str = (typeof arguments[0] == 'object') ? JSON.stringify(arguments[0]) : arguments[0];
		clog('[xGovern WebNode; inst_'+webnode_id+'] : '+str);
	}
};
var webDBFactory = indexedDB || mozIndexedDB || webkitIndexedDB || msIndexedDB;
var webnode_id, xgov_dbcon, xgov_console_override = false;
var bros_info_json_b64, xgov_dbcon_init_callback;
var fobjs = {}, fobj_id = 0;

var xgov_db_req = webDBFactory.open("xgov",1);
	xgov_db_req.onupgradeneeded = function(e){
		xgov_dbcon = e.target.result;
		if(!xgov_dbcon.objectStoreNames.contains('xgov_data')){
			var sto = xgov_dbcon.createObjectStore('xgov_data',{keyPath:'key'});
				sto.createIndex("key", "key", {unique: true});
		}
		//if(xgov_dbcon_init_callback) xgov_dbcon_init_callback();
	}
	xgov_db_req.onsuccess = function(e){
		xgov_dbcon = e.target.result;
		if(xgov_dbcon_init_callback) xgov_dbcon_init_callback();
	}
var xgov_db = {
	put_data:function(key,str,cb){
		if(!cb) throw new Error('Callback function is not defined.');
		if(!xgov_dbcon) return cb(new Error('Database connection not initialized.'));
		var xgov_db_txn = xgov_dbcon.transaction(["xgov_data"], "readwrite");
			xgov_db_txn.onerror = function(e){cb(e);}
		var obst = xgov_db_txn.objectStore("xgov_data");
		var req = obst.add({data:str},key);
			req.onsuccess = function(e){cb(null,true);}
	},
	set_data:function(key,str,cb){this.put_data(key,str,cb);},
	get_data:function(key,cb){
		if(!cb) throw new Error('Callback function is not defined.');
		if(!xgov_dbcon) return cb(new Error('Database connection not initialized.'));
		var xgov_db_txn = xgov_dbcon.transaction(["xgov_data"], "readwrite");
			xgov_db_txn.onerror = function(e){cb(e);}
		var obst = xgov_db_txn.objectStore("xgov_data");
		var req = obst.get(key);
			req.onsuccess = function(e){
				if(req.result === undefined){
					cb(new Error('Cannot find data with key "'+key+'"'));
				}
				else{
					cb(null,req.result.data);
				}
			}
	}
};

importScripts('https://xgov.s3-accelerate.amazonaws.com/nacl-fast.min.js');
importScripts('https://xgov.s3-accelerate.amazonaws.com/pako.min.js');
importScripts('https://xgovern.com/xgov_beta.js?'+((new Date).getTime()));

var time = function(){return Math.floor((new Date).getTime()/1000);}
var mtime = function(){return (new Date).getTime();}
var portable_error = function(e,c){
	if(!e) e = new Error; if(!c) c = "";
	if(typeof e === 'string') e = new Error(e); 
	return {message:e.message, stack:e.stack, name:e.name, code:e.code?e.code:c};
}
var obj_const = Object.prototype.constructor;
var arr_const = Array.prototype.constructor;
var gzip_compress = function(str){return pako.gzip(str,{to:'string'});}
var gzip_decompress = function(str){return pako.ungzip(str,{to:'string'});}
var base64_regex = /^([0-9a-zA-Z+/]{4})*(([0-9a-zA-Z+/]{2}==)|([0-9a-zA-Z+/]{3}=))?$/
var obj_deep_assign = function(a,b){
	var i,c,d;
	if(arguments.length === 2){
		for(var p in b){
			c = a[p];
			d = b[p];
			if(c === undefined || c === null){
				a[p] = d;
			}
			else if(c.constructor === obj_const && d !== null && d.constructor === obj_const){
				a[p] = obj_deep_assign({},c,d);
			}
			else if(c.constructor === arr_const && d !== null && d.constructor === arr_const){
				a[p] = arr_deep_assign([],c,d);
			}
			else{
				a[p] = d;
			}
		}
		return a;
	}
	else if(arguments.length >= 3){
		for(i = 1; i < arguments.length; ++i){
			c = arguments[i];
			if(c !== undefined && c !== null && c.constructor === obj_const) obj_deep_assign(a,c);
		}
		return a;
	}
	else{
		return a;
	}
}
var arr_deep_assign = function(a,b){
	var i,c,d;
	if(arguments.length === 2){
		for(i = 0; i < b.length; ++i){
			c = a[i]; d = b[i];
			if(c === undefined || c === null){
				a[i] = d;
			}
			else if(c.constructor === obj_const && d !== null && d.constructor === obj_const){
				a[i] = obj_deep_assign({},c,d);
			}
			else if(c.constructor === arr_const && d !== null && d.constructor === arr_const){
				a[i] = arr_deep_assign([],c,d);
			}
			else{
				a[i] = d;
			}
		}
		return a;
	}
	else if(arguments.length >= 3){
		for(i = 1; i < arguments.length; ++i){
			c = arguments[i];
			if(c !== undefined && c !== null && c.constructor === obj_const) arr_deep_assign(a,c);
		}
		return a;
	}
	else{
		return a;
	}
}
JSON.decode = function(str){
	var str_saved = str;
	try{
		while(typeof str == "string"){
			var first_char = str.charAt(0);
			if(first_char == '{' || first_char == '['){
				str = JSON.parse(str);
			}
			else if((first_char == 'e' || first_char == 'W') && base64_regex.test(str)){
				var v = false; try{v = atob(str);}catch(e){v=false;}
				if(v !== false) str = v;
				else str = JSON.parse(gzip_decompress(str));
			}
			else{
				str = JSON.parse(gzip_decompress(str));
			}
		}
		return str;
	}
	catch(e){
		console.log(e);
	}
}
JSON.encode = function(obj,gzip){
	try{
		var str = JSON.stringify(obj);
		if(str.charAt(0) == '"' && str.charAt(str.length-1) == '"'){
			if(gzip) return gzip_compress(str.substr(1,str.length-2));
			return str.substr(1,str.length-2);
		}
		else{
			if(gzip) return gzip_compress(str);
			return str;
		}
	}
	catch(e){
		console.log(e);
	}
}

//Hook up prompt UI of parent window
var xgov_prompt_handler = {
	start:function(){},
	get:function(schema,callback){
		var fid = ++fobj_id; fobjs[fid] = {callback:function(e,ret){
			if(callback) callback(e,ret);
		}};
		postMessage({
			xgov:true,
			a:'prompt_get',
			fid:fid,
			schema:schema
		});
	}
};
xgov.set_prompt_handler(xgov_prompt_handler);

var xgov_record_handler = {
	submit:function(obj,options){
		
	},
};
xgov.set_record_handler(xgov_record_handler);

var service_offline_last_triggered = 0;
var abuse_dropped = false;
var ws = {close:function(){if(this.obj) this.obj.close();},type:"ws"};
var ws_connecting = false, ws_current = null;
var wsfid = 0, wsfobj = {}, wsconuid = "";
var ws_send = function(obj){
	if(!obj || !ws_current || ws_current._status != "connected" || abuse_dropped){
		if(obj && obj.callback) obj.callback(new Error("WS is not open or is dropped."));
		return;
	}
	var fid = obj.fid = ++wsfid; wsfobj[fid] = obj;
	if(wsconuid) obj.cid = wsconuid;
	var payload_str = JSON.encode(obj);
	ws_current.send(payload_str);
}
var ws_start = function(){
	try{
		if(ws_connecting) return;
		ws_connecting = true;
		ws_current = ws.obj = new WebSocket('wss://xgovern.com/master-ws/'+bros_info_json_b64);
		ws.obj._status = "connecting";
		ws.obj.onopen = function(e){
			ws.send = ws_send;
			ws.obj._status = "connected";
			console.log("WSS opened");
			//console.log("open");
			//console.log(e);
		}
		ws.obj.onmessage = function(e){
			var payload = JSON.decode(e.data);
			var dat = payload;
			var action = payload.action; if(!action) action = payload.a;
			var fid = payload.fid;
			var server_error = payload.server_error;
			var server_response = payload.server_response;
			var is_progress = payload.progress;
			if(server_error){
				if(server_error == "abuser_drop"){
					abuse_dropped = true;
				}
				else if(server_error == "decode_error"){
					console.log("Payload decoding error");
					console.log(payload);
				}
			}
			else if(server_response){
				if(server_response == "uid_set"){
					wsconuid = payload.uid;
					console.log("WS connection UID set: "+wsconuid);
					xgov.master_node_connection_set(ws);
					postMessage({xgov:true, a:'server_connection_change', v:true, cid:wsconuid});
				}
			}
			else if(action){//Server initiates the response
				try{
					if(action == 'api'){
						if(xgov[dat.func] !== undefined){
							var options = dat.options ? dat.options : {};
							if(!options.sync){
								if(!options.callback)
									options.callback = function(e,data){
										if(e) e = portable_error(e);
										postMessage({xgov:true, fid:fid, data:data, error:e});
									};
								if(!options.onprogress) 
									options.onprogress = function(data){
										postMessage({xgov:true, fid:fid, data:data, progress:true});
									};
							}
							var has_error = false;
							if(!options.sync){
								try{var ret = xgov[dat.func](dat.arg,options);}
								catch(e){postMessage({xgov:true, fid:dat.fid, data:null, error:portable_error(e)});}
							}
							else{
								var ret;
								try{ret = xgov[dat.func](dat.arg,options);}
								catch(e){console.log(e); has_error = true; postMessage({xgov:true, fid:dat.fid, data:null, error:portable_error(e)});}
								if(!has_error) postMessage({xgov:true, fid:dat.fid, data:ret});
							}
						}
						else{
							postMessage({xgov:true, fid:dat.fid, data:false, msg:'Unknown API function call: '+dat.func});
						}
					}
				}
				catch(e){postMessage({xgov:true, fid:fid, result:false, error:portable_error(e)});}
			}
			else if(fid){//Request Callbacks
				var fobj = wsfobj[fid];
				if(fobj){
					if(!is_progress){
						if(fobj.callback){
							if(payload.good){
								var dat = payload.data; if(!dat) dat = {};
								fobj.callback(null,dat);
							}
							else{
								var error = payload.error; if(!error){
									error = (!error && payload.msg) ? new Error(payload.msg) : null;
									error = (!error && payload.message) ? new Error(payload.message) : null;
									error = (!error) ? new Error("Unspecified error received from master node") : null;
								}
								fobj.callback(portable_error(error));
							}
						}
					}
					else{
						if(fobj.onprogress) fobj.onprogress(dat);
					}
				}
			}
			else{
				console.warn("Unrecognized server response: "+JSON.encode(payload));
			}
		}
		ws.obj.onclose = function(e){
			ws_connecting = false;
			wsconuid = "";
			ws.obj._status = "disconnected";
			ws_current = null;
			console.log("WSS closed");
			postMessage({xgov:true, a:'server_connection_change', v:false});
			if(abuse_dropped) return;
			setTimeout(function(){ws_start()}, 3000);
			if(time() - service_offline_last_triggered > 3){
				var wait_t = (service_offline_last_triggered === 0) ? 0 : 6000;
				setTimeout(function(){
					if(ws.obj && ws.obj._status == "connected") return;
				},wait_t);
			}
		}
		ws.obj.onerror = function(e){
			ws_connecting = false;
			ws_current = null;
			console.warn(e);
		}
	}
	catch(e){console.log(e);}
}

//Communication with parent window
this.onmessage = function(e){
	if(!e.data.xgov || !fobjs) return;
	var dat = e.data;
	var fid = dat.fid;
	var action = dat.a;
	var is_progress = dat.progress;
	if(action){
		if(action == 'api'){
			if(xgov[dat.func] !== undefined){
				var options = dat.options ? dat.options : {};
				if(!options.sync){
					if(!options.callback)
						options.callback = function(e,data){
							if(e) e = portable_error(e);
							postMessage({xgov:true, fid:fid, data:data, error:e});
						};
					if(!options.onprogress)
						options.onprogress = function(data){
							postMessage({xgov:true, fid:fid, data:data, progress:true});
						};
				}
				var has_error = false;
				if(!options.sync){
					try{var ret = xgov[dat.func](dat.arg,options);}
					catch(e){postMessage({xgov:true, fid:dat.fid, data:null, error:portable_error(e)});}
				}
				else{
					var ret;
					try{ret = xgov[dat.func](dat.arg,options);}
					catch(e){console.log(e); has_error = true; postMessage({xgov:true, fid:dat.fid, data:null, error:portable_error(e)});}
					if(!has_error) postMessage({xgov:true, fid:dat.fid, data:ret});
				}
			}
			else{
				postMessage({xgov:true, fid:dat.fid, data:false, msg:'Unknown API function call: '+dat.func});
			}
		}
		else if(action == 'set_env'){
			webnode_id = dat.id;
			bros_info_json_b64 = dat.bros_info_json_b64;
			console.log('WebNode Env set.');
			ws_start();
			postMessage({xgov:true, fid:dat.fid, data:true});
		}
		else if(action == 'terminate'){
			console.log('[xGov WebNode '+webnode_id+'] WebNode terminating...');
			postMessage({xgov:true, fid:dat.fid, data:true});
			close();
		}
	}
	else{
		var fobj = fobjs[fid]; if(fobj){
			if(!is_progress){
				if(fobj.cb) fobj.cb(dat.error, dat.result);
				else if(fobj.callback) fobj.callback(dat.error, dat.result);
				delete fobjs[fid];
			}
			else{
				if(fobj.onprogress) fobj.onprogress(dat);
			}
		}
	}
};

xgov_dbcon_init_callback = function(){
	postMessage({xgov:true, a:'webnode_loaded'});
	/*
	xgov_db.get_data("settings",function(e,data){
		console.log('xGovern WebNode Settings Loaded.');
		postMessage({xgov:true, a:'webnode_loaded'});
	});
	*/
}




























